<?php
class Holo6PWA {
  private $racine_sys_holo6 = null;
  public $nonce_scripts = null;

  public function __construct() {
    $this->racine_sys_holo6 = realpath(__DIR__ . "/../");
    $this->nonce_scripts = substr(md5(mt_rand()), 0, 12);
  }

  public function TitrePage()  {
    return "Holo6 - " . $_SERVER["SERVER_NAME"];
  }

  public function RacineSysteme() {
    return $this->racine_sys_holo6;
  }

  function URL_PWA() {
    $scheme = $_SERVER["REQUEST_SCHEME"];
    $scheme = ($scheme) ? ($scheme . "://") : ($scheme . "https://");
    return $scheme . $_SERVER["SERVER_NAME"] . dirname($_SERVER["SCRIPT_NAME"]) . "/";
  }

  public function URL_Racine() {
    return dirname($this->URL_PWA()) . "/";
  }

  public function URL_Holo6_js() {
    return $this->URL_Racine() . "holo6_js/";
  }
  public function URL_Manifest() {
    $lang = substr($_SERVER["HTTP_ACCEPT_LANGUAGE"], 0, 2);
    if ($lang == "fr") {
      return $this->URL_PWA() . "manifest.fr.json.php";
    }
    return $this->URL_PWA() . "manifest.en.json.php";
  }

  public function holo6_pwa_format_mtime_file($filename) {
    $racine = $this->racine_sys_holo6 . "/holo6_js/";
    $chemin_fichier = $racine . $filename;
    if (file_exists($chemin_fichier)) {
      return date("dmy-Gis", filemtime($chemin_fichier));
    }
    return -1;
  }

  function holo6_config_json_path() {
    $json_path = "config/1/Holo6Config-public.json";
    return "$json_path?ver=" . $this->holo6_pwa_format_mtime_file($json_path);
  }
}
$INSTANCE_PWA = new Holo6PWA();
?>
<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8">
  <meta http-equiv="Content-Security-Policy" content="default-src 'self'; script-src 'nonce-<?php echo($INSTANCE_PWA->nonce_scripts); ?>' 'self'; style-src 'self' 'unsafe-inline'; img-src 'self' data:; connect-src 'self' https://*.holo6.com; media-src 'self' https://*.holo6.com blob:;">
  <meta name="author" content="Holo6">
  <meta name="application-name" content="Holo6">
  <meta name="description" content="<?php echo($INSTANCE_PWA->TitrePage()); ?>">
  <meta name="keywords" content="Holo6, IA, artificial intelligence, chatbot, assistant, custom AI assistant, qa, questions, answers">
  <meta name="robots" content="index,nofollow" />
  <link rel="manifest" href="<?php echo($INSTANCE_PWA->URL_Manifest()); ?>" />
  <link rel="search" type="application/opensearchdescription+xml" title="Holo6" href="<?php echo($INSTANCE_PWA->URL_Racine()); ?>OpenSearch.xml.php" />
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <link rel="icon" type="image/png" href="<?php echo($INSTANCE_PWA->URL_PWA()); ?>favicon-64x64.png" />
<?php
  $mtime_css = $INSTANCE_PWA->holo6_pwa_format_mtime_file("holo6.css");
  if ($mtime_css > 0) {
    echo("<link rel=\"stylesheet\" id=\"holo6_ui_style-css\" type=\"text/css\" href=\"" . $INSTANCE_PWA->URL_Holo6_js() . "holo6.css?ver=$mtime_css\" media=\"all\" />");
  }
?>
  <title><?php echo($INSTANCE_PWA->TitrePage()); ?></title>
  <script type="module" src="<?php echo($INSTANCE_PWA->URL_Holo6_js()); ?>holo6.js?ver=<?php echo($INSTANCE_PWA->holo6_pwa_format_mtime_file("holo6.js")); ?>"></script>
  <script nonce="<?php echo($INSTANCE_PWA->nonce_scripts); ?>">
    function MainJS() {
    }
    document.onreadystatechange = () => { if (document.readyState === "complete") { MainJS(); } }
  </script>
  <style>
    body { padding: 0; margin: 2px; }
    div { padding: 0; }
  </style>
</head>
<body>
  <div style="display: inline-block; position: relative; width: 100%; top: 4px; font-family: Roboto, Helvetica, Arial;">
    <div id="h6-pwa-container" style="min-height: 10em; max-width: 297mm; margin: 0 auto; padding: 0;">
      <div id="holo6-ui" data-avatar_url="avatars/base/img_[0-2].png" data-configuration_file="<?php echo($INSTANCE_PWA->holo6_config_json_path()); ?>" data-configuration_inline="base64://eyJhcHBzIjp7InVpIjp7ImZvbnRfc2l6ZSI6MTYsIndpbmRvd19kb2NrYWJsZSI6ZmFsc2UsInNob3dfbWVzc2FnZXNfbGlzdCI6MiwiZnVsbF93aW5kb3dfc3RhdGUiOnsic2l6ZSI6eyJtYXhfaGVpZ2h0IjoiY2FsYygxMDB2aCAtIDcycHgpIn19fX19"></div>
    </div>
  </div>
</body>
</html>