import { holo6_set_element_visibility, holo6_post_notification } from "./common.js";

export function holo6_app_enabled_checkbox(element) {
    const settings_container = document.getElementById("holo6-settings-container");
    if (settings_container) {
        if (element.checked) {
            settings_container.style.opacity = 1.0;
            // settings_container.style.border = "1px solid transparent";
        }
        else {
            settings_container.style.opacity = 0.666;
            // settings_container.style.border = "1px solid #f00";
        }

        const panel_container = document.getElementById("holo6_side_panel_container_bottom");
        if (panel_container) {
            panel_container.style.visibility = element.checked ? "visible" : "hidden";
        }
    }
}

export function holo6_update_ui_window_max_height_type(max_height_prefix_id, new_type=null, set_initial_value=false)  {
    const element_max_height_value = document.getElementById(max_height_prefix_id + "-value");
    const element_max_height_type_selector = document.getElementById(max_height_prefix_id + "-type");
    if (element_max_height_value && element_max_height_type_selector) {
        const element_max_height_editor_str = document.getElementById(max_height_prefix_id + "-edit_str");
        const element_max_height_editor_str_ct = document.getElementById(max_height_prefix_id + "-edit_str-container");
        const element_max_height_editor_int = document.getElementById(max_height_prefix_id + "-edit_int");
        const element_max_height_editor_int_ct = document.getElementById(max_height_prefix_id + "-edit_int-container");
        if (new_type) {
            element_max_height_editor_str.disabled = true;
            element_max_height_editor_int.disabled = true;
            element_max_height_type_selector.value = new_type;
            if (element_max_height_type_selector.value === "fixed") {
                element_max_height_editor_str_ct.style.setProperty("display", "none", "important");
                element_max_height_editor_int_ct.style.setProperty("display", "inline", "important");
                element_max_height_editor_int.disabled = false;
                if (!element_max_height_value.value && !element_max_height_value.value.length) {
                    element_max_height_value.value = "360";
                    element_max_height_editor_int.value = 360;
                }
            }
            else if (element_max_height_type_selector.value === "calc") {
                element_max_height_editor_str_ct.style.setProperty("display", "inline", "important");
                element_max_height_editor_int_ct.style.setProperty("display", "none", "important");
                element_max_height_editor_str.disabled = false;
                if (!element_max_height_value.value && !element_max_height_value.value.length) {
                    element_max_height_value.value = "calc(100vh - 200px)";
                }
                element_max_height_editor_str.value = element_max_height_value.value;
            }
            else {  // auto
                element_max_height_editor_str_ct.style.setProperty("display", "none", "important");
                element_max_height_editor_int_ct.style.setProperty("display", "none", "important");
                if ((element_max_height_type_selector.value === "auto") ||
                    (!element_max_height_value.value && !element_max_height_value.value.length)) {
                    element_max_height_value.value = "auto";
                }
                element_max_height_editor_str.value = "";
                element_max_height_editor_int.value = 0;
            }
        }
        else {
            if (set_initial_value) {
                element_max_height_editor_str.disabled = true;
                element_max_height_editor_int.disabled = true;
                const vh = element_max_height_value.value;
                // alert("(" + max_height_prefix_id + ") : '" + vh + "'");
                if (typeof vh === "string") {
                    if (vh == "auto") {
                        element_max_height_type_selector.value = "auto";
                        element_max_height_editor_str_ct.style.setProperty("display", "none", "important");
                        element_max_height_editor_int_ct.style.setProperty("display", "none", "important");
                        // element_max_height_editor_str.value = "calc(100vh - 200px)";
                        // element_max_height_editor_int.value = 360;
                    }
                    else {
                        const vh_i = parseInt(vh);
                        if (isNaN(vh_i)) {
                            element_max_height_type_selector.value = "calc";
                            element_max_height_editor_str_ct.style.setProperty("display", "inline", "important");
                            element_max_height_editor_int_ct.style.setProperty("display", "none", "important");
                            element_max_height_editor_str.disabled = false;
                            element_max_height_editor_str.value = (vh && vh.length > 0) ? vh : "calc(100vh - 200px)";
                        }
                        else {
                            element_max_height_type_selector.value = "fixed";
                            element_max_height_editor_str_ct.style.setProperty("display", "none", "important");
                            element_max_height_editor_int_ct.style.setProperty("display", "inline", "important");
                            element_max_height_editor_int.disabled = false;
                            element_max_height_editor_int.value = (vh_i >= 250) ? vh_i : 360;
                        }
                    }
                }
                else {
                    element_max_height_type_selector.value = "fixed";
                    element_max_height_editor_str_ct.style.setProperty("display", "none", "important");
                    element_max_height_editor_int_ct.style.setProperty("display", "inline", "important");
                    const vh_i = parseInt(vh);
                    element_max_height_editor_int.value = (vh_i >= 250) ? vh_i : 360;
                }
            }
        }
    }
}

window.addEventListener("load", function() {
    const url_page = new URL(window.location.href);
    const current_page_param = url_page.searchParams.get("page");
    if (current_page_param === "holo6-settings-public" || current_page_param === "holo6-settings-admin") {
        const chk_enable_app = document.getElementById("holo6-app_enabled");
        if (chk_enable_app) {
            holo6_app_enabled_checkbox(chk_enable_app);
        }

        const chk_cl_enable_web_writer = document.getElementById("holo6-cl_enable_web_writer");
        if (chk_cl_enable_web_writer) {
            holo6_set_element_visibility("_holo6-cl_enable_web_writer_test_zone", chk_cl_enable_web_writer.checked, "table-row"); // Initial state
            chk_cl_enable_web_writer.addEventListener("click", function() {
                if (!this.checked) {
                    holo6_set_element_visibility("_holo6-cl_enable_web_writer_test_zone", false, "table-row");
                }
            });
        }

        function _set_event_listeners_window_max_height(max_height_prefix_id) {
            const ui_window_max_height_select_type = document.getElementById(max_height_prefix_id + "-type");
            if (ui_window_max_height_select_type) {
                holo6_update_ui_window_max_height_type(max_height_prefix_id, null, true); // valeur initiale.
                ui_window_max_height_select_type.addEventListener("change", function(event) {
                    // console.log(max_height_prefix_id + " (selector) : " + event.target.value);
                    holo6_update_ui_window_max_height_type(max_height_prefix_id, event.target.value, false);
                });

                const element_max_height_editor_str = document.getElementById(max_height_prefix_id + "-edit_str");
                element_max_height_editor_str.addEventListener("change", function(event) {
                    // console.log(max_height_prefix_id + " (str) : " + event.target.value);
                    const element_max_height_value = document.getElementById(max_height_prefix_id + "-value");
                    if (element_max_height_value) {
                        element_max_height_value.value = event.target.value;
                    }
                });

                const element_max_height_editor_int = document.getElementById(max_height_prefix_id + "-edit_int");
                element_max_height_editor_int.addEventListener("change", function(event) {
                    // console.log(max_height_prefix_id + " (int) : " + event.target.value);
                    const element_max_height_value = document.getElementById(max_height_prefix_id + "-value");
                    if (element_max_height_value) {
                        const vh = element_max_height_value.value;
                        if (typeof vh == "number") {
                            element_max_height_value.value = event.target.value.toString();
                        }
                        else {
                            element_max_height_value.value = event.target.value;
                        }
                    }
                });
            }
        }
        _set_event_listeners_window_max_height("holo6-ui_undocked_window_max_height");
        _set_event_listeners_window_max_height("holo6-ui_full_window_max_height");

        const chk_window_dockable = document.getElementById("holo6-ui_window_dockable");
        if (chk_window_dockable) {
            holo6_set_element_visibility("holo6-ui_docking_window-config", chk_window_dockable.checked, "inline"); // Initial state
            chk_window_dockable.addEventListener("click", function() {
                holo6_set_element_visibility("holo6-ui_docking_window-config", this.checked, "inline");
            });
            holo6_set_element_visibility("holo6-ui_full_window-config", !chk_window_dockable.checked, "block"); // Initial state
            chk_window_dockable.addEventListener("click", function() {
                holo6_set_element_visibility("holo6-ui_full_window-config", !this.checked, "block");
            });
        }

        holo6_set_element_visibility("holo6-reset_config_container_0", true, "inline"); // Initial state
        const btn_reset_config_container = document.getElementById("holo6-reset_config_button_0");
        if (btn_reset_config_container) {
            holo6_set_element_visibility("holo6-reset_config_container_1", false, "inline"); // Initial state
            btn_reset_config_container.addEventListener("click", function() {
                holo6_set_element_visibility("holo6-reset_config_container_0", false, "inline", 2500);
                holo6_set_element_visibility("holo6-reset_config_container_1", true, "inline", 2500);
            });
        }

        holo6_set_element_visibility("holo6-upload_config_container_0", true, "inline"); // Initial state
        const btn_upload_config_container = document.getElementById("holo6-upload_config_button_0");
        if (btn_upload_config_container) {
            holo6_set_element_visibility("holo6-upload_config_container_1", false, "inline"); // Initial state
            btn_upload_config_container.addEventListener("click", function() {
                holo6_set_element_visibility("holo6-upload_config_container_0", false, "inline", -1);
                holo6_set_element_visibility("holo6-upload_config_container_1", true, "inline", -1);
            });
        }

        const btn_upload_config_cancel = document.getElementById("holo6-upload_config_cancel");
        if (btn_upload_config_cancel) {
            btn_upload_config_cancel.addEventListener("click", function() {
                holo6_set_element_visibility("holo6-upload_config_container_1", false, "inline", -1);
                holo6_set_element_visibility("holo6-upload_config_container_0", true, "inline", -1);
            });
        }

        const div_code_clipboard_btn = document.getElementById("holo6-div_code_clipboard_btn");
        if (div_code_clipboard_btn) {
            const div_code_data = document.getElementById("holo6-div_code_data");
            if (div_code_data) {
                div_code_clipboard_btn.addEventListener("click", function() {
                    navigator.clipboard.writeText(div_code_data.innerText);
                    holo6_post_notification("success", HOLO6_TR_JS.holo6_clipboard_notification);
                });
            }
        }
    }
});
