export function getHolo6Instance(id = 0) {  /* Instance depuis le client CL */
    try {
        return window.GetHolo6Instance(id);
    }
    catch (err) {
        return null;
    }
}

export function getHolo6InstanceConfig() { /* Configuration depuis le client UI */
    const instance = getHolo6Instance(1);
    if (instance !== null) {
        return instance.Configuration();
    }
    return null;
}

export function getHolo6InstanceName(id = 1) {
    const instance = getHolo6Instance(id);
    if (instance !== null) {
        return instance.Name();
    }
    return null;
}

export function holo6_post_notification(message_type = "info", message_start_str = "", message_middle_str = null, message_end_str = null) {
    document.getElementById("holo6_post_database_notification_message_start").value = message_start_str;
    document.getElementById("holo6_post_database_notification_message_middle").value = message_middle_str;
    document.getElementById("holo6_post_database_notification_message_end").value = message_end_str;
    document.getElementById("holo6_post_database_notification_type").value = message_type;
    document.getElementById("holo6_post_database_notification_to_translate").value = "1";
    document.getElementById("holo6_post_database_notification").submit();
}

export function holo6_set_element_visibility(element_id, state_bool, state_value, revert_timeout_ms = -1) {
    const container = document.getElementById(element_id);
    if (container) {
        if (state_bool) {
            container.style.setProperty("display", state_value, "important");
            container.style.setProperty("opacity", "1", "important");
        }
        else {
            container.style.setProperty("display", "none", "important");
            container.style.setProperty("opacity", "0", "important");
        }
        if (revert_timeout_ms > 0) {
            window.setTimeout(function () {
                holo6_set_element_visibility(element_id, !state_bool, state_value, -1);
            }, revert_timeout_ms);
        }
        return true;
    }
    return false;
}

export function holo6_manage_confirm_button(btn_id, original_text_str, confirm_text_str, function_to_call) {
    const button = document.getElementById(btn_id);
    if (button) {
        const data_attribute = button.getAttribute("data-holo6_confirm_btn_state");
        if (data_attribute === null || data_attribute === "") {
            button.className = "button button-primary";
            button.setAttribute("data-holo6_confirm_btn_state", "confirm");
            button.value = confirm_text_str;
        }
        else if (data_attribute === "confirm") {
            button.className = "button action";
            button.setAttribute("data-holo6_confirm_btn_state", data_attribute + 1);
            button.removeAttribute("data-holo6_confirm_btn_state");
            button.value = original_text_str;
            function_to_call();
        }
        else {
            button.className = "button action";
            button.removeAttribute("data-holo6_confirm_btn_state");
            button.value = original_text_str;
        }
    }

    window.setTimeout(async function () {
        button.className = "button action";
        button.removeAttribute("data-holo6_confirm_btn_state");
        button.value = original_text_str;
    }, 2500);
}
