import { holo6_set_element_visibility, holo6_manage_confirm_button, holo6_post_notification, getHolo6Instance } from "./common.js";

function holo6_select_db_create_article_source(event, tab_id, btn_id = null) {
    if (tab_id && tab_id.startsWith("holo6-form_")) {
        localStorage.setItem("holo6-select_db_source_tab_id", tab_id);

        const tabcontent = document.getElementsByClassName("holo6_form_db_data");
        for (let i = 0; i < tabcontent.length; i++) {
            tabcontent[i].style.setProperty("display", "none", "important");
        }

        const tabtns = document.getElementsByClassName("holo6_btn_form_db_select_tab");
        for (let i = 0; i < tabtns.length; i++) {
            tabtns[i].className = tabtns[i].className.replace(" active", "");
        }

        const tab_element = document.getElementById(tab_id);
        if (tab_element) {
            tab_element.style.setProperty("display", "block", "important");
        }
        if (event) {
            localStorage.setItem("holo6_select_db_source_btn_id", event.currentTarget.id);
            event.currentTarget.className += " active";
        }
        else if (btn_id) {
            localStorage.setItem("holo6_select_db_source_btn_id", btn_id);
            const btn_el = document.getElementById(btn_id);
            if (btn_el) {
                btn_el.className += " active";
            }
        }
    }
}

export async function holo6_autogen_data_for_web_db(instructions_summary, instructions_title, summary_only = false) {
    const holo6_instance = getHolo6Instance();
    const source_autogen = document.getElementById("holo6-web_article_full_text");

    if ((holo6_instance != null) && source_autogen && (source_autogen.value.length > 0)) {
        holo6_set_element_visibility("holo6-form_add_web_title", true, "table-row");
        holo6_set_element_visibility("holo6-form_add_web_source", true, "table-row");
        holo6_set_element_visibility("holo6-form_add_web_summary", true, "table-row");
        holo6_set_element_visibility("holo6-form_add_web_database-send", true, "table-row");

        const web_article_summary = document.getElementById("holo6-web_article_summary");
        if (web_article_summary) {
            web_article_summary.value = "";
            const title_element = summary_only ? null : document.getElementById("holo6-web_article_title");
            if (title_element) {
                await holo6_instance.WriteToElementId("holo6-web_article_title", instructions_title, source_autogen.value, true).then(() => {
                    holo6_instance.WriteToElementId("holo6-web_article_summary", instructions_summary, source_autogen.value, true);
                });
            }
            else {
                await holo6_instance.WriteToElementId("holo6-web_article_summary", instructions_summary, source_autogen.value, true)
            }
        }
    }
    else {
        holo6_set_element_visibility("holo6-form_add_web_title", true, "table-row");
        holo6_set_element_visibility("holo6-form_add_web_source", true, "table-row");
        holo6_set_element_visibility("holo6-form_add_web_summary", true, "table-row");
        holo6_set_element_visibility("holo6-form_add_web_database-send", true, "table-row");
        console.log("Warning: holo6-cl not found");
        // holo6_post_notification("error", "holo6-cl not found");
    }
}

export async function holo6_get_content_for_local_db(source_autogen_url) {
    if (source_autogen_url.includes("/wp-admin/post.php?")) {
        if (source_autogen_url.includes("/wp-admin/post.php?post=")) {
            source_autogen_url = source_autogen_url.replace("/wp-admin/post.php?post=", "/?page_id=")
            if (source_autogen_url.includes("&action=edit")) {
                source_autogen_url = source_autogen_url.replace("&action=edit", "")
            }
        }
        else {
            holo6_post_notification("error", "Access denied: page is in edit mode");
            return;
        }
    }
    holo6_set_element_visibility("holo6-form_local_db_container", true, "block");
    const resultat = fetch(source_autogen_url, {
        method: "GET",
        // mode: "cors",
        headers: { "Content-Type": "text/html; charset=utf-8", }
    }).then(res => res.text()).then(html => {
        const parser = new DOMParser();
        const htmlDoc = parser.parseFromString(html, "text/html");

        var contenu_page = htmlDoc.getElementById("content");  // Spécifique wordpress
        if (contenu_page === null) {
            contenu_page = htmlDoc.querySelector("main");
            if (contenu_page === null) {
                contenu_page = htmlDoc.body;
            }
        }

        let complete_page_content = contenu_page.textContent;
        const articles = htmlDoc.querySelector("article");
        if (articles) {
            complete_page_content += "\n\n" + articles.textContent;
        }

        complete_page_content = complete_page_content.replaceAll(/^\s+|\s+$/gm, "\n");
        return complete_page_content;
    });
    return resultat;
}

export async function holo6_update_article_text_for_edit(source_url_str) {
    if (source_url_str && source_url_str.length >= 8) {
        holo6_get_content_for_local_db(source_url_str).then(page_content => {
            if (page_content) {
                document.getElementById("holo6-web_article_full_text").value = page_content;
            }
        }).catch((err) => {
            holo6_post_notification("error", "Fetch error (exception)", " : ", err);
        })
    }
    else {
        // holo6_post_notification("error", "Fetch error (bad url)", " : ", source_autogen.value.length.toString());
    }
}

export async function holo6_autogen_data_for_local_db(instructions_summary, instructions_title) {
    const container = document.getElementById("holo6-form_local_db_container");
    if (container) {
        const holo6_instance = getHolo6Instance();
        const source_autogen = document.getElementById("holo6-article_source_autogen");
        if ((holo6_instance != null) && source_autogen) {
            if (source_autogen.value.length >= 8) {
                var source_autogen_url = source_autogen.value;
                holo6_get_content_for_local_db(source_autogen_url).then(page_content => {
                    if (page_content) {
                        document.getElementById("holo6-local_article_source").value = source_autogen_url;
                        document.getElementById("holo6-local_article_full_text").value = page_content;
                        document.getElementById("holo6-local_article_summary").value = "";
                        holo6_instance.WriteToElementId("holo6-local_article_title", instructions_title, source_autogen_url, true).then(() => {
                            holo6_instance.WriteToElementId("holo6-local_article_summary", instructions_summary, page_content, true);
                        });
                    }
                }).catch((err) => {
                    holo6_post_notification("error", "Fetch error (exception)", " : ", err);
                })
            }
            else {
                holo6_post_notification("error", "Fetch error (bad url)", " : ", source_autogen.value.length.toString());
            }
        }
        else {
            console.log("Warning: holo6-cl not found");
            holo6_post_notification("error", "holo6-cl not found");
        }
    }
}

export async function holo6_delete_article_action(source_id) {
    document.getElementById("holo6_post_delete_article_id").value = source_id;
    document.getElementById("holo6_post_delete_article").submit();
}

async function holo6_create_db_edit_buttons() {
    const liste_btns_edit = document.getElementsByClassName("holo6-db-edit-container");
    if (liste_btns_edit && liste_btns_edit.length > 0) {
        for (let i = 0; i < liste_btns_edit.length; i++) {
            const conteneur = liste_btns_edit[i];

            if (true) { // Bouton edition article
                var edit_button = document.createElement("input");
                edit_button.type = "button";
                edit_button.className = "button action";
                edit_button.value = HOLO6_TR_JS.holo6_edit_label;
                edit_button.onclick = async function () {
                    window.location.href = "?page=holo6-settings-database&detail_article=" + conteneur.dataset.source;
                };
                conteneur.appendChild(edit_button);
            }

            if (true) { // Bouton supprimer article
                var suppr_button = document.createElement("input");
                suppr_button.type = "button";
                suppr_button.id = "holo6-del-db-btn-" + conteneur.dataset.uid;
                suppr_button.className = "button action";
                suppr_button.style = "margin-left: 1em;"
                suppr_button.value = HOLO6_TR_JS.holo6_delete_label;
                suppr_button.onclick = function () {
                    holo6_manage_confirm_button("holo6-del-db-btn-" + conteneur.dataset.uid, HOLO6_TR_JS.holo6_delete_label, HOLO6_TR_JS.holo6_confirm_delete_label, async () => {
                        await holo6_delete_article_action(conteneur.dataset.source);
                    });
                }
                conteneur.appendChild(suppr_button);
            }
        }
    }

}

window.addEventListener("load", function () {
    const url_page = new URL(window.location.href);
    const current_page_param = url_page.searchParams.get("page");
    if (current_page_param && typeof current_page_param === "string") {
        if (current_page_param === "holo6-settings-database") {
            const select_db_source_tab_id = localStorage.getItem("holo6-select_db_source_tab_id");
            if (select_db_source_tab_id) {
                const select_db_source_btn_id = localStorage.getItem("holo6_select_db_source_btn_id");
                holo6_select_db_create_article_source(null, select_db_source_tab_id, select_db_source_btn_id);
            }
            else {
                // holo6_select_db_create_article_source(null, "holo6-form_add_local_database", "holo6-btn_form_db_local_database");
                holo6_select_db_create_article_source(null, "holo6-form_add_web_database", "holo6-btn_form_db_web_database");
            }

            const holo6_cl_element = document.getElementById("holo6-cl");
            if (holo6_cl_element) {  // Si il y a cet élément, c'est que la génération de résumé par IA est disponible.
            }
            else {
                const holo6_form_cl_disabled_notif = document.getElementById("holo6_form_cl_disabled_notif");
                if (holo6_form_cl_disabled_notif) {
                    holo6_form_cl_disabled_notif.style.setProperty("display", "block");
                }
            }
        }

        const btn_form_db_local_database = document.getElementById("holo6-btn_form_db_local_database");
        if (btn_form_db_local_database) {
            btn_form_db_local_database.addEventListener("click", function (event) {
                holo6_select_db_create_article_source(event, "holo6-form_add_local_database", null);
            });
        }

        const btn_form_db_web_database = document.getElementById("holo6-btn_form_db_web_database");
        if (btn_form_db_web_database) {
            btn_form_db_web_database.addEventListener("click", function (event) {
                holo6_select_db_create_article_source(event, "holo6-form_add_web_database", null);
            });
        }

        const autogen_data_for_local_btn = document.getElementById("holo6-autogen_data_for_local_btn");
        if (autogen_data_for_local_btn) {
            autogen_data_for_local_btn.addEventListener("click", function (event) {
                holo6_autogen_data_for_local_db(HOLO6_TR_JS.holo6_instructs_gen_summary_local, HOLO6_TR_JS.holo6_instructs_gen_title_local);
            });
        }

        const autogen_data_for_web_btn = document.getElementById("holo6-autogen_data_for_web_btn");
        if (autogen_data_for_web_btn) {
            autogen_data_for_web_btn.addEventListener("click", function (event) {
                holo6_autogen_data_for_web_db(HOLO6_TR_JS.holo6_instructs_gen_summary_generic, HOLO6_TR_JS.holo6_instructs_gen_title_generic, true);
            });
        }

        const db_edit_refresh_article_btn = document.getElementById("holo6-db_edit_refresh_article_btn");
        if (db_edit_refresh_article_btn) {
            db_edit_refresh_article_btn.addEventListener("click", function (event) {
                if (db_edit_refresh_article_btn.dataset.article_url) {
                    holo6_update_article_text_for_edit(db_edit_refresh_article_btn.dataset.article_url);
                }
            });
        }

        holo6_create_db_edit_buttons();
    }
});
