<?php

// Voir https://www.htmlgoodies.com/php/create-a-file-uploader-in-wordpress/

require_once($_SERVER["DOCUMENT_ROOT"] . "/wp-load.php");

if (!defined("ABSPATH")) {
    die("We're sorry, but you can not directly access this file.");
}

if (!function_exists("add_action") || !defined("HOLO6_PLUGIN_BASENAME")) {
    echo("Hi there!  I'm just a plugin, not much I can do when called directly.");
    exit;
}


require_once constant("HOLO6_PLUGIN_DIR") . "plugin_pages/libs/utils.php";
require_once constant("HOLO6_PLUGIN_DIR") . "plugin_pages/libs/notifications.php";
require_once constant("HOLO6_PLUGIN_DIR") . "plugin_pages/libs/holo6_client_settings.php";

load_plugin_textdomain("holo6", false, dirname(constant("HOLO6_PLUGIN_BASENAME")) . "/languages");

if ( ! current_user_can("upload_files") ) {
	wp_die(__("Rejected", "holo6"));
}

function _holo6_echo_client_settings_redirect() {
    echo("<a href=\"" . esc_url(admin_url() . "admin.php?page=holo6-settings-" . $_POST["holo6_redirect_page"]) . "\">" . __("Return to previous page", "holo6") . "</a>");
}

function _holo6_validation_nom($nom_fichier) {
    $notifications_manager = new Holo6Notifications();
    $nom_fichier_attendu = "Holo6Config-site_" . holo6_get_current_site_name_format() . "-" . $_POST["holo6_redirect_page"] . "@" . $_SERVER["SERVER_NAME"] . ".json";
    if ($nom_fichier === $nom_fichier_attendu) {
        if ($_POST["holo6_redirect_page"] === "admin") {
            return constant("HOLO6_CLIENT_DIR") . Holo6JSClientSettings::writer_setting_file_path(false);
        }
        else if ($_POST["holo6_redirect_page"] === "public") {
            return constant("HOLO6_CLIENT_DIR") . Holo6JSClientSettings::public_setting_file_path(false);
        }
    }
    else {
        $notifications_manager->addNotificationError(__("JSON file rejected.", "holo6") . " " . sprintf(__("The expected file name is \"%s\"", "holo6"), $nom_fichier_attendu));
    }
    return null;
}

function _holo6_upload_settings_finalize($notification_str, $is_error=false) {
    if (isset($_POST["holo6_redirect_page"])) {
        $notifications_manager = new Holo6Notifications();
        if ($is_error) {
            $notifications_manager->addNotificationError($notification_str);
        }
        else {
            $notifications_manager->addNotificationSuccess($notification_str);
        }

        // _holo6_echo_client_settings_redirect();

        header("HTTP/1.0 301 Moved Permanently");
        header("Location: " . esc_url(admin_url() . "admin.php?page=holo6-settings-" . $_POST["holo6_redirect_page"]));
        header("Connection: close");
        exit();
    }
    else {
        wp_die($notification_str);
    }
}

if (isset($_FILES["holo6_json_settings_file"]) && $_FILES["holo6_json_settings_file"]["name"] && isset($_POST["holo6_redirect_page"]) && defined("HOLO6_CLIENT_DIR")) {
    if ($_FILES["holo6_json_settings_file"]["error"] == UPLOAD_ERR_OK) {
        if ($_FILES["holo6_json_settings_file"]["size"] > (128 * 1024)) { // Limite de taille de fichiers (en octets)
            _holo6_upload_settings_finalize(__("The file size is too large.", "holo6"), true);
        }
        else {
            $chemin_fichier_json = _holo6_validation_nom($_FILES["holo6_json_settings_file"]["name"]);
            if ($chemin_fichier_json) {
                if (move_uploaded_file($_FILES["holo6_json_settings_file"]["tmp_name"], $chemin_fichier_json)) {
                    _holo6_upload_settings_finalize(sprintf(__("Holo6 client settings restored (%s).", "holo6"), $_FILES["holo6_json_settings_file"]["name"]), false);
                }
                else {
                    // _holo6_echo_client_settings_redirect();
                    _holo6_upload_settings_finalize(__("Error moving file", "holo6"), true);
                }
            }
            else {
                // _holo6_echo_client_settings_redirect();
                _holo6_upload_settings_finalize(__("Bad file type", "holo6"), true);
            }
        }
    }
    else {
        $phpFileUploadErrors = array(
            0 => "There is no error, the file uploaded with success",
            1 => "The uploaded file exceeds the upload_max_filesize directive in php.ini",
            2 => "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
            3 => "The uploaded file was only partially uploaded",
            4 => "No file was uploaded",
            6 => "Missing a temporary folder",
            7 => "Failed to write file to disk.",
            8 => "A PHP extension stopped the file upload.",
        );
        _holo6_upload_settings_finalize(__("Error", "holo6") . " : " . $phpFileUploadErrors[$_FILES["holo6_json_settings_file"]["error"]], true);
    }
}
else {
    if (isset($_FILES["holo6_json_settings_file"]) && $_FILES["holo6_json_settings_file"]["name"]) {
        _holo6_upload_settings_finalize(__("Undefined error", "holo6"), true);
    }
    else {
        _holo6_upload_settings_finalize(__("No file to upload", "holo6"), true);
    }
}

?>