<?php

require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/utils.php";
require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/notifications.php";
require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/holo6_agents_manager.php";
require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/holo6_client_settings.php";
require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/holo6_private_settings.php";
require_once HOLO6_PLUGIN_DIR . "plugin_pages/client_settings/client_settings_post.php";


function _holo6_render_settings_archive($is_admin_profil) {
    $nom_fichier_config = "Holo6Config-site_" . holo6_get_current_site_name_format() . "-" . ($is_admin_profil ? "admin" : "public") . "@" . $_SERVER["SERVER_NAME"] . ".json";
    echo("<th class=\"holo6_side_panel_th\">");
        echo("<a class=\"button button-primary\" href=\"" . constant("HOLO6_CLIENT_URL") . (($is_admin_profil) ? Holo6JSClientSettings::writer_setting_file_path(false) : Holo6JSClientSettings::public_setting_file_path(false)) . "\" download=\"" . $nom_fichier_config ."\">" . __("Download settings", "holo6") . "</a>");
    echo("</th>");

    echo("</tr><tr>");

    echo("<th class=\"holo6_side_panel_th\">");
    echo("<span id=\"holo6-upload_config_container_0\">");
        echo("<button class=\"button button-secondary\" id=\"holo6-upload_config_button_0\" type=\"button\">" . __("Upload previous settings", "holo6") . "</button>");
    echo("</span>");
    echo("<span id=\"holo6-upload_config_container_1\" style=\"display: none;\">");
        echo("<div style=\"padding: 0.5em;\">" . __("Upload previous settings", "holo6") . "</div>");
        echo("<form action=\"" . (constant("HOLO6_PLUGIN_URL") . "plugin_pages/client_settings/_client_settings_upload.php") . "\" method=\"post\" enctype=\"multipart/form-data\" style=\"padding: 0px; margin: 0px;\">");
            echo("<input type=\"file\" accept=\"application/json\" name=\"holo6_json_settings_file\" id=\"holo6_json_settings_file\">");
            echo("<input type=\"hidden\" name=\"holo6_redirect_page\" value=\"" . ($is_admin_profil ? "admin" : "public") . "\">");
            echo("<input type=\"submit\" class=\"button button-primary\" style=\"margin-left: 0.5em;\" value=\"" . esc_attr__("Send", "holo6") . "\" name=\"holo6_client_settings_submit\" />");
            echo("<span id=\"holo6-upload_config_cancel\" class=\"button button-secondary\" style=\"margin-left: 0.5em;\">" . __("Cancel", "holo6") . "</span>");
        echo("</form>");
    echo("</span>");
    echo("</th>");
}

// function _holo6_render_client_settings_top_panel($is_admin_profil) {
//     echo("<div id=\"holo6_side_panel_container_top\">");
//     if ($is_admin_profil) {
//         echo("<th class=\"holo6_side_panel_th\"><a href=\"?page=holo6-settings-public\">" . __("Public AI settings", "holo6") . "</a></th>");
//     }
//     else {
//         echo("<th class=\"holo6_side_panel_th\"><a href=\"?page=holo6-settings-admin\">" . __("AI writing settings", "holo6") . "</a></th>");
//     }
//     echo("</div>");
// }

function holo6_render_client_settings_custom_commands($client_commands_dict) {
    $edition_commande_txt = "";
    foreach ($client_commands_dict as $cmd => $instructions) {
        $edition_commande_txt .= "\"" . $cmd . "\"" . " : " . json_encode($instructions, JSON_UNESCAPED_UNICODE) . ",\n";
    }
    $placeholder_txt = str_replace("'", "\\'", __("\"/k\": { \"instructions\": {\"command\": \"chat_input\", \"params\": \"Instructions to inject into the conversation\"} },", "holo6"));

    echo("<div class=\"holo6_div_conf_block\"><span class=\"holo6-label\">" . __("Commands / Shortcuts", "holo6")) . "</span>";
    echo("<textarea id=\"holo6-client_commands\" class=\"holo6_input_conf_text\" style=\"min-height: 4em;\" name=\"client_commands\" rows=\"3\" cols=\"180\" placeholder=\"" . esc_attr($placeholder_txt) . "\" >" . esc_attr($edition_commande_txt) . "</textarea>");
    echo("</div>");
}

function _holo6_render_client_settings_bottom_panel($is_admin_profil) {
    echo("<div id=\"holo6_side_panel_container_bottom\">");
    echo("<table class=\"widefat striped\" style=\"position: relative; margin-left: auto; max-width: 36em; right: 1em;\" role=\"presentation\"><tbody>");
    echo("<tr>");
    _holo6_render_settings_archive($is_admin_profil);
    echo("</tr><tr>");

    echo("<th class=\"holo6_side_panel_th\">");
    echo("<span id=\"holo6-reset_config_container_0\">");
        echo("<button class=\"button reset\" id=\"holo6-reset_config_button_0\" type=\"button\">" . __("Reset", "holo6") . "</button>");
    echo("</span>");
    echo("<span id=\"holo6-reset_config_container_1\" style=\"display: none;\">");
        echo("<form action=\"\" method=\"post\" style=\"padding: 0px; margin: 0px;\">");
            echo("<input type=\"hidden\" name=\"holo6_post_js_config_action\" value=\"restore\" />");
            echo("<input type=\"hidden\" name=\"holo6_post_js_config_admin\" value=\"" . (($is_admin_profil===true) ? "1" : "0") . "\" />");
            echo("<input type=\"submit\" class=\"button button-primary\" name=\"holo6_reset_config_action\" value=\"" . esc_attr__("Are you sure to reset to default settings ?", "holo6") . "\" />");
        echo("</form>");
    echo("</span>");
    echo("</th>");

    echo("</tr>");
    echo("</tbody></table>");
    echo("</div>");
}

function _holo6_current_embeddable_client_tag($plugin_settings, $force_window_dockable=true) {
    $chemin_config = $plugin_settings->current_settings_file_path(true);
    $avatar_param = $plugin_settings->avatar_config->get_avatar_html_param();
    if ($force_window_dockable) {
        return (esc_html("<!-- wp:html -->")."<br>") . esc_attr("<div id=\"holo6-ui\"" .  $avatar_param . " data-configuration_file=\"" . $chemin_config . "\" data-configuration_inline=\"base64://eyJhcHBzIjp7InVpIjp7IndpbmRvd19kb2NrYWJsZSI6ZmFsc2V9fX0=\"></div>") . ("<br>".esc_html("<!-- /wp:html -->"));
    }
    else {
        return (esc_html("<!-- wp:html -->")."<br>") . esc_attr("<div id=\"holo6-ui\"" .  $avatar_param . " data-configuration_file=\"" . $chemin_config . "\"></div>") . ("<br>" . esc_html("<!-- /wp:html -->"));
    }
}


function holo6_render_client_settings_main_page($is_admin_profil = false) {

    if (holo6_js_update_db_post()) {
        ;
    }

    $api_serveur_editable = false; // Défini si on peut modifier les champs liés à l'API (nom du serveur et clé d'API publique)

    $settings_tmp = Holo6JSClientSettings::SelectSettingsCTOR($is_admin_profil);
    if (!$settings_tmp->load_profil_current_site()) {
        echo("<p>Holo6 : " . __("Internal error: config file not found", "holo6") . "</p>");
        return;
    }

    echo("<div class=\"wrap holo6_base\">");
    // _holo6_render_client_settings_top_panel($is_admin_profil);

    echo("<span style=\"display: inline-flex; vertical-align: middle;\">");
    echo("<h1 class=\"wp-heading-inline\">" . sprintf(__("Holo6 AI Settings on %s", "holo6"), "<span class=\"holo6_surligne_titre\">" . holo6_current_site_title_name(false) . "</span>") . "</h1>");
    //echo("<p>admin=" . (($is_admin_profil===true) ? "OUI" : "NON") . "</p>"); // TEST

    if ($is_admin_profil) {
        echo("<h2 style=\"color: #af4b4b; width: fit-content; margin-left: 1em;\">" . __("Private client : AI Settings for administrators in the admin panel", "holo6") . "</h2>");
    }
    else {
        echo("<h2 style=\"color: #58719d; width: fit-content; margin-left: 1em;\">" . __("Public client : AI Settings for everyone outside admin panel", "holo6") . "</h2>");
    }
    echo("</span>");

    echo("<hr class=\"wp-header-end\"><br>");

    $cle_indefinie_client = false;
    if ($is_admin_profil) {
        $private_settings = new Holo6PrivateSettings();
        if (! $private_settings->APIKeyDefined()) {
            $cle_indefinie_client = true;
        }
        // $holo6_php_client = new Holo6PHPClient();
        // if (! $holo6_php_client->valideDatabasePassword(true)) {
        //     $cle_indefinie_client = true;
        // }
    }

    if ($cle_indefinie_client) {
        echo("<div style=\"padding-left: 2rem; width: fit-content;\">");
            echo("<div><h2>" . __("The admin client requires access to private data. So, you must set the password of the database.", "holo6") . "</h2></div>");
            echo("<div><a href=\"?page=holo6-settings-database\">" . __("Go to database settings", "holo6") . "</a></div>");
        echo("</div>");
    }
    else {
        $param_window_pos_x = array_key_exists("left", $settings_tmp->ui_main_window_style) ? ($settings_tmp->ui_main_window_style["left"]) :
            (array_key_exists("right", $settings_tmp->ui_main_window_style) ? ($settings_tmp->ui_main_window_style["right"]) : 0);
        if (is_string($param_window_pos_x) && preg_match('/px$/', $param_window_pos_x)) {
            $param_window_pos_x = intval(preg_replace('/px$/', '', $param_window_pos_x));
        }

        $param_window_pos_y = array_key_exists("top", $settings_tmp->ui_main_window_style) ? ($settings_tmp->ui_main_window_style["top"]) :
            (array_key_exists("bottom", $settings_tmp->ui_main_window_style) ? ($settings_tmp->ui_main_window_style["bottom"]) : 0);
        if (is_string($param_window_pos_y) && preg_match('/px$/', $param_window_pos_y)) {
            $param_window_pos_y = intval(preg_replace('/px$/', '', $param_window_pos_y));
        }

        echo("<form action=\"\" method=\"post\">");
            echo("<input type=\"hidden\" name=\"holo6_post_js_config_action\" value=\"update\" />");
            echo("<input type=\"hidden\" name=\"holo6_post_js_config_admin\" value=\"" . (($is_admin_profil===true) ? "1" : "0") . "\" />");
            echo("<input type=\"hidden\" id=\"holo6-ui_undocked_window_max_height-value\" name=\"ui_undocked_window_max_height\" value=\"" . $settings_tmp->get_ui_undocked_window_max_height_value() . "\" />");
            echo("<input type=\"hidden\" id=\"holo6-ui_full_window_max_height-value\" name=\"ui_full_window_max_height\" value=\"" . $settings_tmp->get_ui_full_window_max_height_value() . "\" />");

            echo("<div style=\"padding-left: 2rem; width: fit-content; display: inline-block;\"><label class=\"holo6-label\" for=\"holo6-app_enabled\">" . __("Enable", "holo6") . "</label>&nbsp;<input type=\"checkbox\" name=\"app_enabled\" id=\"holo6-app_enabled\" " . (($settings_tmp->app_enabled) ? "checked" : "") . " onchange=\"holo6_app_enabled_checkbox(this)\" /></div>");
            
            echo ("<div style=\"position: relative; float: right; right: 24px; text-align: right;\">");
                echo("<div style=\"display: inline-block; text-align: right;\"><label class=\"holo6-label\" for=\"holo6-app_debug_level\">" . __("Debug mode", "holo6") . "</label>&nbsp;<input type=\"checkbox\" name=\"app_debug_level\" id=\"holo6-app_debug_level\" " . (($settings_tmp->app_debug_level >= 1) ? "checked" : "") . " /></div>");
                echo("<div style=\"max-width: 24em; margin-right=\"6px\"; text-align: right;\">" . __("Enable extra informations display to facilitate problem-solving", "holo6") . "</div>");
            echo("</div>");
    
            echo("<div id=\"holo6-settings-container\">");
                echo("<div>");
                    echo("<h2 style=\"padding-left: 2rem;\">" . __("API", "holo6") . "</h2>");
                    echo("<div style=\"padding-left: 3rem; width: calc(100% - 6rem);\">");
                        echo("<table class=\"form-table\" role=\"presentation\" style=\"max-width: 1280px;\">");
                        echo("<tr>");
    
                        echo("<td style=\"padding: 0px 0px;\" scope=\"row\"><label class=\"holo6-label\" for=\"holo6-api_server-input\">" . __("Server name", "holo6") . "</label><br><input type=\"text\" class=\"holo6_input_conf_line\" id=\"holo6-api_server-input\" name=\"api_server\"" . ($api_serveur_editable ? "":" readonly") . " value=\"" . $settings_tmp->api_settings->api_server . "\" /></td>");
                        echo("<td style=\"padding: 0px 0px;\"><label class=\"holo6-label\" for=\"holo6-api_key-input\">" . __("Public API key", "holo6") . "</label><br><input type=\"text\" class=\"holo6_input_conf_line\" id=\"holo6-api_key-input\" name=\"api_key\" " . ($api_serveur_editable ? "":"readonly") . " value=\"" . $settings_tmp->api_settings->api_key . "\" /></td>");
    
                        $selectable_agent = false; // Si on permet de choisir l'agent...
                        $collection_name = $selectable_agent ? null : Holo6AgentsManager::get_collection_name_for_agent($settings_tmp->api_settings->api_agent);
                        if ($collection_name) {
                            echo("<td style=\"padding: 0px 0px;\"><label class=\"holo6-label\" for=\"holo6-api_agent-input\">" . __("Agent", "holo6") . "&nbsp;/&nbsp;<span><a href='?page=holo6-settings-database&collection_name=" . $collection_name . "'>" . __("Edit knowledge base", "holo6") . "</a></span>" . "</label><br>");
                        }
                        else {
                            echo("<td style=\"padding: 0px 0px;\"><label class=\"holo6-label\" for=\"holo6-api_agent-input\">" . __("Agent", "holo6") . "</label><br>");
                        }
                        
                        $holo6_agents_manager = new Holo6AgentsManager();
                        $agents_list = $holo6_agents_manager->GetAgentsList();
                        if ($agents_list) {
                            if ($selectable_agent) {
                                echo ("<select class=\"holo6_input_conf_line_mini\" id=\"holo6-api_agent-input\" name=\"api_agent\">");
                                echo ("<option value=\"" . $settings_tmp->api_settings->api_agent . "\" selected>" . $settings_tmp->api_settings->api_agent . "</option>");
                                foreach ($agents_list as $agent) {
                                    if (($agent["name"] === $settings_tmp->api_settings->api_agent)) {
                                    }
                                    else {
                                        if (!$is_admin_profil && $agent["permissions"]["requires_secret_key"]) {
                                        }
                                        else {
                                            echo("<option value=\"" . $agent["name"] . "\">" . $agent["name"] . "</option>");
                                        }
                                    }
                                }
                            }
                            else {  // Agent aligné sur une base de données fixe.
                                echo("<input type=\"text\" class=\"holo6_input_conf_line\" id=\"holo6-api_agent-input\" name=\"api_agent\" readonly value=\"" . $settings_tmp->api_settings->api_agent . "\" /></td>");
                            }
                            echo("</select></td>");
                        }
                        else {
                            echo("<input type=\"text\" class=\"holo6_input_conf_line\" id=\"holo6-api_agent-input\" name=\"api_agent\" value=\"" . $settings_tmp->api_settings->api_agent . "\" " . ($api_serveur_editable ? "":"readonly") . " /></td>");
                        }
    
                        echo("<input type=\"hidden\" name=\"api_max_completion_tokens\" value=\"1024\" />");
                        echo("<td style=\"padding: 0px 0px;\"><label class=\"holo6-label\" for=\"holo6-api_temperature-input\">" . __("Temperature", "holo6") . "</label><br><input type=\"number\" class=\"holo6_input_conf_line\" id=\"holo6-api_temperature-input\" style=\"width: 6em;\" name=\"api_temperature\" step=\"0.1\" min=\"0.1\" max=\"1.0\" value=\"" . $settings_tmp->api_settings->get_api_temperature() . "\" /></td>");
                        echo("<td style=\"padding: 0px 0px;\"><label class=\"holo6-label\" for=\"holo6-api_top_p-input\">" . __("Top probs", "holo6") . "</label><br><input type=\"number\" class=\"holo6_input_conf_line\" id=\"holo6-api_top_p-input\" style=\"width: 6em;\" name=\"api_top_p\" step=\"0.1\" min=\"0.1\" max=\"1.0\" value=\"" . $settings_tmp->api_settings->get_api_top_p() . "\" /></td>");
                        echo("</tr>");
                        echo("</table><br>");

                        $roles_system_instructions_esc = holo6_esc_html($settings_tmp->api_settings->get_roles_system_instructions());
                        echo("<div class=\"holo6_div_conf_block\"><span class=\"holo6-label\">" . __("Global instructions", "holo6") . "</span><textarea class=\"holo6_input_conf_text\" style=\"min-height: 13em;\" id=\"holo6-roles_system_instructions\" name=\"roles_system_instructions\" title=\"" . __("Main instructions", "holo6") . "\" rows=\"9\" cols=\"180\">" . $roles_system_instructions_esc . "</textarea></div>");
                        $roles_current_message_extra_esc = holo6_esc_html($settings_tmp->roles_current_message_extra);
                        echo("<div class=\"holo6_div_conf_block\"><span class=\"holo6-label\">" . __("Contextual instructions", "holo6") . "</span><textarea class=\"holo6_input_conf_text\" style=\"min-height: 4em;\" id=\"holo6-roles_current_message_extra\" name=\"roles_current_message_extra\" title=\"" . ($settings_tmp->injectPageContent() ? __("Used to present contextual informations extracted from the current webpage", "holo6") : __("Injected with any user messages. The current page content is not included.", "holo6")) . "\" rows=\"4\" cols=\"180\">" . $roles_current_message_extra_esc . "</textarea></div>");
    
                        holo6_render_client_settings_custom_commands($settings_tmp->client_commands);
                    echo("</div>");
                echo("</div>");
                echo("<br>");
                echo("<div>");
                    echo("<h2 style=\"padding-left: 2rem;\">" . __("UI", "holo6") . "</h2>");
                    echo("<div style=\"padding-left: 3rem; width: calc(100% - 6rem);\">");
                        echo("<table class=\"form-table\" role=\"presentation\"><tbody>");
                        echo("<tr>");
                            echo("<td scope=\"row\" class=\"holo6_table_td_prem_colonne\"><label class=\"holo6-label\" for=\"holo6-ui_active_window_title\">" . __("Window title", "holo6") . "</label></td>");
                            echo("<td><input type=\"text\" class=\"holo6_input_conf_line\" id=\"holo6-ui_active_window_title\" name=\"ui_active_window_title\" value=\"" . esc_attr($settings_tmp->ui_active_window_title) . "\" /></td>");
                        echo("</tr>");
                        echo("<tr>");
                            echo("<td scope=\"row\" class=\"holo6_table_td_prem_colonne\"><label class=\"holo6-label\" for=\"holo6-roles_welcome_message\">" . __("Welcome message", "holo6") . "</label></td>");
                            echo("<td><input type=\"text\" class=\"holo6_input_conf_line\" id=\"holo6-roles_welcome_message\" name=\"roles_welcome_message\" value=\"" . esc_attr($settings_tmp->roles_welcome_message) . "\" /></td>");
                        echo("</tr>");
                        echo("<tr>");
                            echo("<td scope=\"row\" class=\"holo6_table_td_prem_colonne\"><label class=\"holo6-label\" for=\"holo6-roles_welcome_topics\">" . __("Welcome topics (semicolon separated)", "holo6") . "</label></td>");
                            echo("<td><input type=\"text\" class=\"holo6_input_conf_line\" id=\"holo6-roles_welcome_topics\" name=\"roles_welcome_topics\" value=\"" . esc_attr($settings_tmp->get_roles_welcome_topics_str()) . "\" placeholder=\"" . esc_attr__("Hello. Can you explain what you can do for me ?;Alternative subject 1;Alternative subject 2;", "holo6") . "\" /></td>");
                        echo("</tr>");
                        echo("<tr>");
                            echo("<td scope=\"row\" class=\"holo6_table_td_prem_colonne\"><label class=\"holo6-label\" for=\"holo6-ui_font_size\">" . __("Font size", "holo6") . "</label></td>");
                            echo("<td><input type=\"number\" class=\"holo6_input_conf_line_mini\" id=\"holo6-ui_font_size\" name=\"ui_font_size\" step=\"1\" min=\"14\" max=\"28\" value=\"" . $settings_tmp->ui_font_size . "\" /></td>");
                        echo("</tr>");
                        echo("<tr>");
                            echo("<td scope=\"row\" class=\"holo6_table_td_prem_colonne\"><label class=\"holo6-label\" for=\"holo6-enable_avatar\">" . __("Display avatar", "holo6") . "</label></td>");
                            echo("<td><input type=\"checkbox\" name=\"enable_avatar\" id=\"holo6-enable_avatar\" " . (($settings_tmp->avatar_config->get_avatar_enabled()==0) ? "" : "checked") . " /></td>");
                        echo("</tr>");
                        echo("<tr>");
                            echo("<td scope=\"row\" class=\"holo6_table_td_prem_colonne\"><label class=\"holo6-label\" for=\"holo6-ui_notification_type_after_response\">" . __("Action after each response (requires sourced articles inside the database)", "holo6") . "</label></td>");
                            echo("<td><select name=\"ui_notification_type_after_response\">");
                                $ui_notification_type_after_response = $settings_tmp->get_ui_notification_type_after_response();
                                echo("<option value=\"2\"". (($ui_notification_type_after_response==2) ? " selected" : "") . ">" . __("None", "holo6") . "</option>");
                                echo("<option value=\"1\"". (($ui_notification_type_after_response==1) ? " selected" : "") . ">" . __("Show sources after the response", "holo6") . "</option>");
                                echo("<option value=\"3\"". (($ui_notification_type_after_response==3) ? " selected" : "") . ">" . __("Show a sources notification", "holo6") . "</option>");
                                echo("<option value=\"4\"". (($ui_notification_type_after_response==4) ? " selected" : "") . ">" . __("Suggest related topics", "holo6") . "</option>");
                            echo("</select></td>");
                        echo("</tr>");
                        echo("<tr>");
                        echo("<td scope=\"row\" class=\"holo6_table_td_prem_colonne\"><label class=\"holo6-label\" for=\"holo6-ui_show_messages_list\">" . __("Display the complete messages list", "holo6") . "</label></td>");
                        echo("<td><select name=\"ui_show_messages_list\">");
                            $ui_show_messages_list = $settings_tmp->ui_show_messages_list;
                            echo("<option value=\"0\"". (($ui_show_messages_list==0) ? " selected" : "") . ">" . __("Never", "holo6") . "</option>");
                            echo("<option value=\"1\"". (($ui_show_messages_list==1) ? " selected" : "") . ">" . __("Only in non-dockable window", "holo6") . "</option>");
                            echo("<option value=\"2\"". (($ui_show_messages_list==2) ? " selected" : "") . ">" . __("Always", "holo6") . "</option>");
                        echo("</select></td>");
                        echo("</tr>");
                        echo("</tbody></table>");
    
                        echo("<table class=\"form-table\" role=\"presentation\" style=\"max-width: 1200px;\"><tbody>");
                        echo("<tr>");
                        echo("<td scope=\"row\" class=\"holo6_table_td_prem_colonne\"><label class=\"holo6-label\">" . __("Colors", "holo6") . "</label></td>");
                            echo("<td><label class=\"holo6-label\" for=\"holo6-ui_front_color\">" . __("Front color", "holo6") . "</label></td>");
                            echo("<td><input type=\"color\" class=\"holo6_input_conf_color\" id=\"holo6-ui_front_color\" name=\"ui_front_color\" value=\"" . $settings_tmp->ui_style_light_theme_params["front_color"] . "\" /></td>");
                            echo("<td scope=\"row\"><label class=\"holo6-label\" for=\"holo6-ui_background_color\">" . __("Background color", "holo6") . "</label></td>");
                            echo("<td><input type=\"color\" class=\"holo6_input_conf_color\" id=\"holo6-ui_background_color\" name=\"ui_background_color\" value=\"" . $settings_tmp->ui_style_light_theme_params["background_color"] . "\" /></td>");
                            echo("<td scope=\"row\"><label class=\"holo6-label\" for=\"holo6-ui_background_color_alt\">" . __("Secondary background color", "holo6") . "</label></td>");
                            echo("<td><input type=\"color\" class=\"holo6_input_conf_color\" id=\"holo6-ui_background_color_alt\" name=\"ui_background_color_alt\" value=\"" . $settings_tmp->ui_style_light_theme_params["background_color_alt"] . "\" /></td>");
                        echo("</tr>");
                        echo("<tr>");
                            echo("<td scope=\"row\" class=\"holo6_table_td_prem_colonne\"></td>");
                            echo("<td><label class=\"holo6-label\" for=\"holo6-ui_active_color\">" . __("Active color", "holo6") . "</label></td>");
                            echo("<td><input type=\"color\" class=\"holo6_input_conf_color\" id=\"holo6-ui_active_color\" name=\"ui_active_color\" value=\"" . $settings_tmp->ui_style_light_theme_params["active_color"] . "\" /></td>");
                            echo("<td scope=\"row\"><label class=\"holo6-label\" for=\"holo6-ui_highlight_color_static\">" . __("Icons and frames color", "holo6") . "</label></td>");
                            echo("<td><input type=\"color\" class=\"holo6_input_conf_color\" id=\"holo6-ui_highlight_color_static\" name=\"ui_highlight_color_static\" value=\"" . $settings_tmp->ui_style_light_theme_params["highlight_color_static"] . "\" /></td>");
                            echo("<td scope=\"row\"><label class=\"holo6-label\" for=\"holo6-ui_highlight_color_hover\">" . __("Hover color", "holo6") . "</label></th>");
                            echo("<td><input type=\"color\" class=\"holo6_input_conf_color\" id=\"holo6-ui_highlight_color_hover\" name=\"ui_highlight_color_hover\" value=\"" . $settings_tmp->ui_style_light_theme_params["highlight_color_hover"] . "\" /></td>");
                        echo("</tr>");
                        echo("</tbody></table>");
    
                        if ($is_admin_profil && $settings_tmp->get_cl_accept_web_writer()) {
                            echo("<table class=\"form-table\" role=\"presentation\" id=\"holo6-ui_size_limits_config-container\"><tbody>");
                            echo("<tr><td scope=\"row\" class=\"holo6_table_td_prem_colonne\"><label class=\"holo6-label\" for=\"holo6-cl_enable_web_writer\">" . __("Integral editor", "holo6") . "</label></td>");
                                echo("<td><input type=\"checkbox\" name=\"cl_enable_web_writer\" id=\"holo6-cl_enable_web_writer\" " . (($settings_tmp->get_cl_enable_web_writer()) ? "checked" : "") . " />");
                                /* ! Le textarea est préfixe par _ sinon l'édition est refusée car les éléments dont l'id commence par 'holo6' sont refusés par le module Holo6JS/CL */
                                echo("<span class=\"description\" id=\"holo6-cl_enable_web_writer-description\"><span>" . __("Generates within any compatible element inside pages.", "holo6") . "<br></span><textarea id=\"_holo6-cl_enable_web_writer_test_zone\" class=\"holo6_input_conf_line holo6_table_row_cond_enabled\" style=\"margin-top: 0.5em; vertical-align: middle; max-height: 5em;\" rows=\"3\" placeholder=\"" . sprintf(esc_attr__("This is a test zone. Hit %s followed by your instructions and then Enter or Tab to start. Use backspace to remove the last response.\neg: // Hello. What is role here ?", "holo6"), $settings_tmp->get_cl_web_writer_command()) . "\"></textarea></span>");
                            echo("</td></tr>");
                            echo("</tbody></table>");
                        }
    
                        if ($is_admin_profil) {
                            echo("<input type=\"hidden\" name=\"ui_window_dockable\" value=\"on\" />");
                        }
                        else {
                            // echo("<div class=\"holo6_div_conf_line\">" . __("Dockable window", "holo6") . ": <input type=\"checkbox\" name=\"ui_window_dockable\" id=\"holo6-ui_window_dockable\" " . (($settings_tmp->ui_window_dockable) ? "checked" : "") . " /></div>");
                            // echo("<br>");
                            echo("<table class=\"form-table\" role=\"presentation\"><tbody>");
                            echo("<tr><td scope=\"row\" class=\"holo6_table_td_prem_colonne\"><label class=\"holo6-label\" for=\"holo6-ui_window_dockable\">" . __("Dockable window integration", "holo6") . "</label></td>");
                                echo("<td>");
                                echo("<input type=\"checkbox\" name=\"ui_window_dockable\" id=\"holo6-ui_window_dockable\" " . (($settings_tmp->get_ui_window_dockable_option()) ? "checked" : "") . " />");
                                echo("<span style=\"margin-left: 8px;\" class=\"description\" id=\"holo6-ui_window_dockable-description\">" . __("Define whether the app will be integrated on each page as a floating window or as a manually integrable element", "holo6") . "</span>");
                            echo("</td></tr>");
                            echo("</tbody></table>");

                            echo("<table class=\"form-table\" role=\"presentation\" id=\"holo6-height_config\"><tbody>");
                            echo("<tr>");
                                echo("<td scope=\"row\" class=\"holo6_table_td_prem_colonne\"><label class=\"holo6-label\" for=\"holo6-height_config-label\">" . __("Height settings", "holo6") . "</label></td>");
                                echo("<td style=\"width: 32em;\">");
                                    echo("<p style=\"margin-right: 4px; width: fit-content;\">" . __("Full window", "holo6") . "</p>");
                                    echo("<select id=\"holo6-ui_full_window_max_height-type\"><option value=\"auto\">" . __("Auto", "holo6") . "</option><option value=\"fixed\">" . __("Fixed", "holo6") . "</option><option value=\"calc\">" . __("Calc", "holo6") . "</option></select>");
                                    echo("<span id=\"holo6-ui_full_window_max_height-edit_str-container\" style=\"margin-left: 2px; display: none;\"><input type=\"text\" class=\"holo6_input_conf_line_mini\" style=\"width: 18em;\" id=\"holo6-ui_full_window_max_height-edit_str\" placeholder=\"calc(100vh - 200px)\" /></span>");
                                    echo("<span id=\"holo6-ui_full_window_max_height-edit_int-container\" style=\"margin-left: 2px; display: none;\"><input type=\"number\" class=\"holo6_input_conf_line_mini\" style=\"width: 6em;\" id=\"holo6-ui_full_window_max_height-edit_int\" step=\"10\" min=\"250\" max=\"5000\" /><span style=\"margin-left: 2px;\">" . __("px", "holo6") . "</span>");
                                echo("</td>");
                                echo("<td style=\"width:1em;\">&nbsp;</td>");
                                echo("<td style=\"width: 32em;\">");
                                    echo("<p style=\"margin-right: 4px; width: fit-content;\">" . __("Docked window", "holo6") . "</p>");
                                    echo("<select id=\"holo6-ui_undocked_window_max_height-type\"><option value=\"auto\">" . __("Auto", "holo6") . "</option><option value=\"fixed\">" . __("Fixed", "holo6") . "</option><option value=\"calc\">" . __("Calc", "holo6") . "</option></select>");
                                    echo("<span id=\"holo6-ui_undocked_window_max_height-edit_str-container\" style=\"margin-left: 2px; display: none;\"><input type=\"text\" class=\"holo6_input_conf_line_mini\" style=\"width: 18em;\" id=\"holo6-ui_undocked_window_max_height-edit_str\" placeholder=\"calc(100vh - 200px)\" /></span>");
                                    echo("<span id=\"holo6-ui_undocked_window_max_height-edit_int-container\" style=\"margin-left: 2px; display: none;\"><input type=\"number\" class=\"holo6_input_conf_line_mini\" style=\"width: 6em;\" id=\"holo6-ui_undocked_window_max_height-edit_int\" step=\"10\" min=\"250\" max=\"5000\" /><span style=\"margin-left: 2px;\">" . __("px", "holo6") . "</span>");
                                echo("</td>");
                                echo("<td style=\"width: auto;\"></td>");
                            echo("</tr>");
                            echo("</tbody></table>");
                            
                            echo("<table class=\"form-table\" role=\"presentation\" id=\"holo6-ui_full_window-config\"><tbody>");
                                echo("<tr><td scope=\"row\" class=\"holo6_table_td_prem_colonne\"></td><td>");
                                    echo("<div><span>" . __("If the window is not dockable, you'll need to manually insert it into a page or article of your choice by using the following code. You may need to switch the WordPress editor to \"Code editor\" mode.).", "holo6") . "</span><br>");
                                    echo("<div id=\"holo6-div_code_data-container\">");
                                        echo("<div id=\"holo6-div_code_data\">" . _holo6_current_embeddable_client_tag($settings_tmp, true) . "</div>");
                                        echo("<div id=\"holo6-div_code_clipboard_btn\"><div class=\"button\">" . __("Copy", "holo6") . "</div></div>");
                                    echo("</div>");
                                echo("</td></tr>");
                            echo("</tbody></table>");
                        }
    
                        echo("<table class=\"form-table\" style=\"width: 100%;\" role=\"presentation\" id=\"holo6-ui_docking_window-config\"><tbody>");
                            echo("<tr>");
                                echo("<td scope=\"row\" class=\"holo6_table_td_prem_colonne\"><label class=\"holo6-label\" for=\"holo6-ui_window_reference_y\">" . __("Position", "holo6") . "</label></td>");
                                echo("<td style=\"width: 16em;\"><select class=\"holo6_input_conf_line_mini\" name=\"ui_window_reference_y\"><option value=\"top\" " . (array_key_exists("top", $settings_tmp->ui_main_window_style) ? "selected": "") . ">" . __("Top", "holo6") . "</option><option value=\"bottom\" " . (array_key_exists("bottom", $settings_tmp->ui_main_window_style) ? "selected": "") . ">" . __("Bottom", "holo6") . "</option></select><input type=\"number\" class=\"holo6_input_conf_line_mini\" id=\"holo6-ui_window_pos_y\" style=\"width: 6em; margin-left: 2px;\" name=\"ui_window_pos_y\" step=\"5\" min=\"0\" max=\"50000\" value=\"" . $param_window_pos_y . "\" />&nbsp;<span>" . __("px", "holo6") . "</span></td>");
                                echo("<td style=\"width:1em;\">&nbsp;</td>");
                                echo("<td style=\"width: 16em;\"><select class=\"holo6_input_conf_line_mini\" name=\"ui_window_reference_x\"><option value=\"left\" " . (array_key_exists("left", $settings_tmp->ui_main_window_style) ? "selected": "") . ">" . __("Left", "holo6") . "</option><option value=\"right\" " . (array_key_exists("right", $settings_tmp->ui_main_window_style) ? "selected": "") . ">" . __("Right", "holo6") . "</option></select><input type=\"number\" class=\"holo6_input_conf_line_mini\" id=\"holo6-ui_window_pos_x\" style=\"width: 6em;margin-left: 2px;\" name=\"ui_window_pos_x\" step=\"5\" min=\"0\" max=\"50000\" value=\"" . $param_window_pos_x . "\" />&nbsp;<span>" . __("px", "holo6") . "</span></td>");
                                echo("<td style=\"width: auto;\"></td>");
                            echo("</tr>");
                            echo("<tr>");
                                echo("<td scope=\"row\" class=\"holo6_table_td_prem_colonne\"><label class=\"holo6-label\" for=\"holo6-ui_undock_on_mouse_hover\">" . __("Show on mouse hover", "holo6") . "</label></td>");
                                echo("<td><input type=\"checkbox\" name=\"ui_undock_on_mouse_hover\" id=\"holo6-ui_undock_on_mouse_hover\" " . (($settings_tmp->ui_undock_on_mouse_hover) ? "checked" : "") . " /></td>");
                            echo("</tr>");
                            echo("<tr id=\"holo6-ui_min_width_for_undocked-container\">");
                                echo("<td scope=\"row\" class=\"holo6_table_td_prem_colonne\"><label class=\"holo6-label\" for=\"holo6-ui_min_width_for_undocked\">" . __("Minimal screen window size to show app window", "holo6") . "</label></td>");
                                echo("<td><input type=\"number\" class=\"holo6_input_conf_line\" id=\"holo6-ui_min_width_for_undocked\" style=\"width: 8em;\" name=\"ui_min_width_for_undocked\" step=\"10\" min=\"0\" max=\"12000\" value=\"" . $settings_tmp->ui_min_width_for_undocked . "\" />&nbsp;<span>" . __("px", "holo6") . "</span></td>");
                            echo("</tr>");
                        echo("</tbody></table>");
    
                        echo("<br>");
                    echo("</div>");
                echo("</div>");
            echo("</div>");
            echo("<br>");
            echo("<div id=\"holo6_end_panel_container\">" . get_submit_button(esc_attr__("Save Edits", "holo6"), "primary", "holo6_js_submit_config_action", true) . "</div>");
        echo("</form>");
        _holo6_render_client_settings_bottom_panel($is_admin_profil);
    }
    echo("</div>"); // class = wrap
}

function holo6_render_client_settings_page($is_admin_profil = false) {
    if (is_admin()) {
        Holo6Notifications_from_POST();
        Holo6Notifications_form_HTML($is_admin_profil ? "admin" : "public");
        holo6_render_client_settings_main_page($is_admin_profil);
    }
}

?>