<?php

require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/utils.php";
require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/holo6_client_settings.php";
// require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/notifications.php";


function holo6_js_update_db_post() {
    /* Dans le cas où la page reçoit une commande POST, on met à jour la configuration (l'envoi du formulaire provoque l'envoi sur la page elle même). */
    if (! is_admin()) {
        ;
    }
    else if (isset($_POST["holo6_post_js_config_action"])) {
        $holo6_post_js_config_admin = ($_POST["holo6_post_js_config_admin"] === "1");

        $settings_export = Holo6JSClientSettings::SelectSettingsCTOR($holo6_post_js_config_admin);

        if ($_POST["holo6_post_js_config_action"] == "update_activate") {
            if (isset($_POST["holo6_js_submit_config_action"])) {
                if ($_SERVER["REQUEST_METHOD"] == "POST") {
                    $settings_export->load_profil_current_site();

                    if (array_key_exists("app_enabled", $_POST)) {
                        $settings_export->app_enabled = (($_POST["app_enabled"] == "on") ? true : false);
                    }
                    else {
                        $settings_export->app_enabled = false;
                    }

                    $settings_export->export_settings_json();
                    do_action("admin_notices");
                    return true;
                }
            }
        }
        else if ($_POST["holo6_post_js_config_action"] == "update") {
            if (isset($_POST["holo6_js_submit_config_action"])) {
                if ($_SERVER["REQUEST_METHOD"] == "POST") {
                    $settings_export->load_profil_current_site();

                    if (array_key_exists("app_enabled", $_POST)) {
                        $settings_export->app_enabled = (($_POST["app_enabled"] == "on") ? true : false);
                    }
                    else {
                        $settings_export->app_enabled = false;
                    }

                    if (array_key_exists("app_debug_level", $_POST)) {
                        $settings_export->app_debug_level = (($_POST["app_debug_level"] == "on") ? 2 : 0);  // 1 = avertissements de configuration, 2 = journal des messages
                    }
                    else {
                        $settings_export->app_debug_level = 0;
                    }

                    $settings_export->api_settings->api_agent = $_POST["api_agent"];  // A assigner le plus tôt possible, car tous les appels à meta/setvar en dépendront.

                    $settings_export->api_settings->api_server = $_POST["api_server"];
                    $settings_export->api_settings->api_key = $_POST["api_key"];
                    $settings_export->api_settings->api_max_completion_tokens = intval($_POST["api_max_completion_tokens"]);
                    $settings_export->api_settings->set_api_temperature($_POST["api_temperature"]);
                    $settings_export->api_settings->set_api_top_p($_POST["api_top_p"]);

                    $client_commands = stripslashes($_POST["client_commands"]);
                    $client_commands = trim($client_commands);
                    $client_commands = str_replace("}\n\"", "},\n\"", $client_commands);
                    $client_commands = str_replace("}\r\n\"", "},\r\n\"", $client_commands);
                    while (holo6_str_endsWith($client_commands, ",")) {
                        $client_commands = substr($client_commands, 0, -1);;
                    }
                    $settings_export->client_commands = json_decode("{" . $client_commands . "}");
                    $settings_export->api_settings->set_roles_system_instructions(stripslashes($_POST["roles_system_instructions"]));
                    $settings_export->roles_current_message_extra = stripslashes($_POST["roles_current_message_extra"]);
                    $settings_export->roles_welcome_message = stripslashes($_POST["roles_welcome_message"]);

                    if (array_key_exists("roles_welcome_topics", $_POST) && strlen($_POST["roles_welcome_topics"]) > 0) {
                        $liste_sujets = explode(";", $_POST["roles_welcome_topics"]);
                        $settings_export->roles_welcome_topics = [];
                        foreach ($liste_sujets as $sujet) {
                            $sujet = trim(stripslashes($sujet));
                            if (strlen($sujet) > 0) {
                                array_push($settings_export->roles_welcome_topics, $sujet);
                            }
                        }
                    }
                    else {
                        $settings_export->roles_welcome_topics = null;
                    }

                    $settings_export->ui_active_window_title = stripslashes($_POST["ui_active_window_title"]);

                    if (array_key_exists("ui_window_dockable", $_POST)) {
                        $settings_export->ui_window_dockable = (($_POST["ui_window_dockable"] == "on") ? true : false);
                    }
                    else {
                        $settings_export->ui_window_dockable = false;
                    }

                    if (array_key_exists("ui_notification_type_after_response", $_POST)) {
                        $settings_export->ui_notification_type_after_response = intval($_POST["ui_notification_type_after_response"]);
                    }
                    else {
                        $settings_export->ui_notification_type_after_response = 4;
                    }


                    $settings_export->avatar_config->set_avatar_enabled((array_key_exists("enable_avatar", $_POST) && ($_POST["enable_avatar"] == "on")));

                    if (array_key_exists("ui_show_messages_list", $_POST)) {
                        $settings_export->ui_show_messages_list = intval($_POST["ui_show_messages_list"]);
                    }
                    else {
                        $settings_export->ui_show_messages_list = 1;
                    }

                    if (array_key_exists("cl_enable_web_writer", $_POST)) {
                        $settings_export->cl_enable_web_writer = (($_POST["cl_enable_web_writer"] == "on") ? true : false);
                    }
                    else {
                        $settings_export->cl_enable_web_writer = false;
                    }

                    // holo6_log("TEST" . $_POST["ui_undocked_window_max_height"] . " : " . $_POST["ui_full_window_max_height"]);

                    if (array_key_exists("ui_undocked_window_max_height", $_POST)) {
                        $settings_export->set_ui_undocked_window_max_height($_POST["ui_undocked_window_max_height"]);
                    }

                    if (array_key_exists("ui_full_window_max_height", $_POST)) {
                        $settings_export->set_ui_full_window_max_height($_POST["ui_full_window_max_height"]);
                    }

                    $settings_export->ui_font_size = intval($_POST["ui_font_size"]);
                    $settings_export->ui_style_light_theme_params["front_color"] = $_POST["ui_front_color"];
                    $settings_export->ui_style_light_theme_params["active_color"] = $_POST["ui_active_color"];
                    $settings_export->ui_style_light_theme_params["background_color"] = $_POST["ui_background_color"];
                    $settings_export->ui_style_light_theme_params["background_color_alt"] = $_POST["ui_background_color_alt"];
                    $settings_export->ui_style_light_theme_params["highlight_color_static"] = $_POST["ui_highlight_color_static"];
                    $settings_export->ui_style_light_theme_params["highlight_color_hover"] = $_POST["ui_highlight_color_hover"];

                    if (array_key_exists("ui_undock_on_mouse_hover", $_POST)) {
                        $settings_export->ui_undock_on_mouse_hover = (($_POST["ui_undock_on_mouse_hover"] == "on") ? true : false);
                    }
                    else {
                        $settings_export->ui_undock_on_mouse_hover = false;
                    }

                    $settings_export->ui_min_width_for_undocked = $_POST["ui_min_width_for_undocked"];

                    $ui_window_reference_x = $_POST["ui_window_reference_x"];
                    $ui_window_reference_y = $_POST["ui_window_reference_y"];
                    $ui_window_pos_x = $_POST["ui_window_pos_x"];
                    $ui_window_pos_y = $_POST["ui_window_pos_y"];
                    if ($ui_window_reference_x && $ui_window_reference_y && $ui_window_pos_x && $ui_window_pos_y) {
                        $settings_export->ui_main_window_style =  array($ui_window_reference_x => ($ui_window_pos_x."px"), $ui_window_reference_y => ($ui_window_pos_y."px"));
                    }

                    if ($settings_export->export_settings_json() === true) {
                        ;
                    }
                    do_action("admin_notices");
                    return true;
                }
            }
        }
        else if ($_POST["holo6_post_js_config_action"] == "restore") {
            if (isset($_POST["holo6_reset_config_action"])) {
                if ($_SERVER["REQUEST_METHOD"] == "POST") {
                    $settings_export->load_profil_current_site();
                    $force_values_array = array("core" =>
                        array("enabled" => (($settings_export->app_enabled != null) ? $settings_export->app_enabled : false))
                    );
                    if ($settings_export->restore_settings(false, true, $force_values_array) === true) {
                        if ($settings_export->export_settings_json() === true) {
                            ;
                        }
                    }
                    do_action("admin_notices");
                    return true;
                }
            }
        }
    }
    return false;
}

?>