<?php

require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/utils.php";
require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/holo6_client.php";
require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/notifications.php";
require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/holo6_private_settings.php";


function holo6_database_remove_article_db_post() {
    if (! is_admin()) {
        ;
    }
    else {
        if (isset($_POST["holo6_post_delete_article_id"])) {
            $source_name = urldecode($_POST["holo6_post_delete_article_id"]);
            $holo6_php_client = new Holo6PHPClient();
            $notifications_manager = new Holo6Notifications();

            if ($holo6_php_client->valideDatabasePassword(true) === true) {
                $delete_result = $holo6_php_client->DBDeleteSourceFromCurrentCollection($source_name);
                if ($delete_result->validation_json("data", "dict") === true) {
                    if ($delete_result->get("data")["result"] === 1) {
                        $notifications_manager->addNotificationSuccess(sprintf(__("The content from \"%s\" has been successfully deleted.", "holo6"), $source_name));
                    }
                    else {
                        $notifications_manager->addNotificationError(sprintf(__("An error occurred while deleting content from \"%s\" : %s", "holo6"), $source_name, $delete_result->toString()));
                    }
                }
                else {
                    $notifications_manager->addNotificationError(sprintf(__("An error occurred while deleting content from \"%s\" : %s", "holo6"), $source_name, $delete_result->toString()));
                }
            }
            else {
                $notifications_manager->addNotificationError(sprintf(__("Unable to delete content from \"%s\" : Wrong password", "holo6"), $source_name));
            }
            do_action("admin_notices");
            return true;
        }
    }
    return false;
}

function holo6_database_update_db_post() {
    if (! is_admin()) {
        ;
    }
    else if (isset($_POST["holo6_post_database_db_action"])) {
        $notifications_manager = new Holo6Notifications();

        if ($_POST["holo6_post_database_db_action"] == "add_article_data") {
            if (isset($_POST["holo6_database_submit_article_action"])) {
                $article_title = isset($_POST["article_title"]) ? $_POST["article_title"] : null;
                $article_source = isset($_POST["article_source"]) ? $_POST["article_source"] : null;
                if ($article_source == null || strlen($article_source) === 0) {
                    $article_source = $article_title;
                }
                $article_summary = isset($_POST["article_summary"]) ? $_POST["article_summary"] : null;
                if (($article_source != null && strlen($article_source) > 2) && ($article_summary != null && strlen($article_summary) > 6)) {
                    $article_title = stripslashes($article_title);
                    $article_source = stripslashes($article_source);
                    $article_summary = stripslashes($article_summary);
                    $holo6_client = new Holo6PHPClient();
                    if (isset($_POST["article_full_text"])) {
                        $article_full_text = stripslashes($_POST["article_full_text"]);
                    }
                    else {
                        $article_full_text = $article_summary;
                    }
                    $add_data_result = $holo6_client->DBAddCollectionData($article_title, $article_source, $article_summary, $article_full_text);
                    if ($add_data_result->validation_json("data", "dict") && $add_data_result->get("data")["result"]) {
                        $notifications_manager->addNotificationSuccess(sprintf(__("Article %s added", "holo6"), $article_source));
                    }
                    else {
                        $notifications_manager->addNotificationError(sprintf(__("An error occurred while adding \"%s\" to the database", "holo6"), $article_source));
                    }
                }
                else {
                    $notifications_manager->addNotificationError(sprintf(__("An error occurred while adding \"%s\" to the database", "holo6"), $article_source));
                }
                do_action("admin_notices");
                return true;
            }
        }
        else if ($_POST["holo6_post_database_db_action"] == "create_database") {
            if (isset($_POST["holo6_database_submit_db_action"])) {
                if ($_SERVER["REQUEST_METHOD"] == "POST") {
                    $holo6_client = new Holo6PHPClient();
                    $database_password = $_POST["database_password"];
                    if (strlen($database_password) >= 8 && strlen($database_password) < 64) {
                        $holo6_client->DBCreatePrivateDataBase($database_password);
                        if ($holo6_client->valideDatabasePassword(true) === true) {
                            $notifications_manager->addNotificationSuccess(sprintf(__("The database was created with password \"%s\".", "holo6"), $holo6_client->GetSearchDBPassword()));
                        }
                        else {
                                $notifications_manager->addNotificationError(sprintf(__("An error occurred while creating the database", "holo6")));
                        }
                    }
                    else {
                        $notifications_manager->addNotificationError(sprintf(__("The password must have a length of %d-%d characters.", "holo6"), 8, 64));
                    }
                    do_action("admin_notices");
                    return true;
                }
            }
        }
        else if ($_POST["holo6_post_database_db_action"] == "reset_database_passwords") {
            if (isset($_POST["holo6_database_reset_db_pw_action"])) {
                $holo6_database_settings = new Holo6PrivateSettings();
                $holo6_database_settings->resetPasswords();
                do_action("admin_notices");
                return true;
            }
        }
    }
    return false;
}

function holo6_database_update_config_post() {
    if (! is_admin()) {
        ;
    }
    else if (isset($_POST["holo6_post_database_config_action"])) {
        $current_network_id = holo6_current_site_id();

//         $notifications_manager = new Holo6Notifications();
        if ($_POST["holo6_post_database_config_action"] == "update") {
            if (isset($_POST["holo6_private_submit_config_action"])) {
                if ($_SERVER["REQUEST_METHOD"] == "POST") {
                    $settings_tmp = new Holo6PrivateSettings();
                    $settings_tmp->setSecretAPIKey($_POST["api_key"]);
                    do_action("admin_notices");
                    return true;
                }
            }

            // if (isset($_POST["holo6_database_change_collection_action"])) {
            //     if ($_SERVER["REQUEST_METHOD"] == "POST") {
            //         update_network_option($current_network_id, "holo6_database-current_collection_name", $_POST["collection_name"]);
            //         do_action("admin_notices");
            //         return true;
            //     }
            // }
        }
    }
    return false;
}

?>
