<?php

require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/utils.php";

class Holo6AvatarConfig {
    private $default_avatar_path = "avatars/base/img_[0-2].png";
    private $current_network_id = 0;

    public function __construct($force_current_network_id=null) {
        $this->current_network_id = ($force_current_network_id===null) ? holo6_current_site_id() : $force_current_network_id;
    }

    public function get_avatar_path() {
        return get_network_option($this->current_network_id, "holo6_avatar-path", $this->default_avatar_path);
    }

    public function get_avatar_enabled() {
        $avatar_bot_path = $this->get_avatar_path();
        return ($avatar_bot_path != null) && (strlen($avatar_bot_path) > 0);
    }

    public function set_avatar_enabled($enabled) {
        if ($enabled) {
            $this->set_avatar_path($this->default_avatar_path);  /* Temporaire, en attendant de permettre de choisir parmis plusieurs avatars */
        }
        else {
            $this->set_avatar_path(null);
        }
    }

    public function get_avatar_html_param() {
        $avatar_bot_path = $this->get_avatar_path();
        if (($avatar_bot_path != null) && (strlen($avatar_bot_path) > 0)) {
            return " data-avatar_url=\"" . $avatar_bot_path . "\"";
        }
        else {
            return "";
        }
    }

    public function set_avatar_path($avatar_path) {
        if ($avatar_path != null && strlen($avatar_path) > 0) {
            return update_network_option($this->current_network_id, "holo6_avatar-path", $avatar_path);
        }
        else {
            return update_network_option($this->current_network_id, "holo6_avatar-path", null);
        }
    }

    // public function get_inline_html_param() {
    // }
};

?>