<?php

require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/utils.php";
require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/holo6_client.php";
require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/notifications.php";
require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/holo6_avatar_config.php";
require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/holo6_common_settings.php";
require_once HOLO6_PLUGIN_DIR . "plugin_pages/libs/holo6_private_settings.php";


// function get_option_to_bool($var, $alt_value) {
//     $v = get_network_option(holo6_current_site_id(), $var, null);
//     if ($v === null) {
//         return $alt_value;
//     }
// //     echo($var. ":" . gettype($v).":".$v." <br> ");
//     if ($v === true or $v === "1") {
//         return true;
//     }
//     return false;
// }

class Holo6JSClientAPISettings {
	public $api_server = null;
	public $api_key = null;
	public $api_agent = null;
	public $api_temperature = null;
	public $api_max_completion_tokens = null;
	public $roles_system_instructions = null;
	public $api_top_p = null;

    public $agent_role = null;
    private $send_instructions_to_server = false;

    public function __construct($agent_role) {
        $this->agent_role = $agent_role;
        
        if (is_multisite()) {
            $this->send_instructions_to_server = is_main_site(get_current_blog_id());
        }
        else {
            $this->send_instructions_to_server = true;
        }
    }

    public function LocalSettingsOnly() { // -> bool
        return $this->send_instructions_to_server;
    }

    public function load_profil_from_array_str($json_data) {
        if ($json_data === null) {
        }
        else if ($this->agent_role) {
            if ($json_data["core"]["client"]["api"]["server"] === null) {
            }
            else {
                $config_api = $json_data["core"]["client"]["api"];
                $config_roles_list = $json_data["core"]["client"]["roles"];
                $config_role = $config_roles_list[$this->agent_role];
                $this->api_server = $config_api["server"];
                $this->api_key = $config_api["key"];
                $this->api_agent = $config_role["api"]["agent"];
                $this->api_max_completion_tokens = $config_role["api"]["max_completion_tokens"];
                $this->api_temperature = $config_role["api"]["temperature"];
                $this->api_top_p = $config_role["api"]["top_p"];
                $this->roles_system_instructions = $config_role["instructions"]["system"];
                return true;
            }
        }
        return false;
    }

    public function clear_remote_settings() {
        if ($this->send_instructions_to_server) {
            $client_tmp = new Holo6PHPClient();
            $client_tmp->SetAgentVar($this->api_agent, "system_instructs", null);
            $client_tmp->SetAgentVar($this->api_agent, "temperature", null);
            $client_tmp->SetAgentVar($this->api_agent, "top_p", null);
        }
    }

    public function send_remote_settings() {
        if ($this->send_instructions_to_server) {
            $client_tmp = new Holo6PHPClient();
            $client_tmp->SetAgentVar($this->api_agent, "system_instructs", $this->roles_system_instructions);
            $client_tmp->SetAgentVar($this->api_agent, "temperature", $this->api_temperature);
            $client_tmp->SetAgentVar($this->api_agent, "top_p", $this->api_top_p);
        }
    }

    public function get_roles_system_instructions() {
        if ($this->send_instructions_to_server) {
            $client_temp = new Holo6PHPClient();
            $online_response = $client_temp->GetAgentVar($this->api_agent, "system_instructs");
            if ($online_response) {
                return $online_response;
            }
            return $this->roles_system_instructions;
        }
        else {
            return $this->roles_system_instructions;
        }
    }

    public function set_roles_system_instructions($system_instructions_str) {
        if ($this->send_instructions_to_server) {
            $client_temp = new Holo6PHPClient();
            if ($client_temp->SetAgentVar($this->api_agent, "system_instructs", $system_instructions_str)) {
                $this->roles_system_instructions = "";  // Cela permetttra de faire le transfert entre le JSON et le serveur distant.
            }
            else {
                $this->roles_system_instructions = $system_instructions_str;
            }
        }
        else {
            $this->roles_system_instructions = $system_instructions_str;
        }
    }

    public function get_api_temperature() {
        if ($this->send_instructions_to_server) {
            $client_temp = new Holo6PHPClient();
            $online_response = $client_temp->GetAgentVar($this->api_agent, "temperature");
            if ($online_response) {
                return $online_response;
            }
            if ($this->api_temperature !== null) {
                return $this->api_temperature;
            }
            return 0.5;
        }
        else {
            return $this->api_temperature;
        }
    }

    public function set_api_temperature($api_temperature) {
        if ($this->send_instructions_to_server) {
            $client_temp = new Holo6PHPClient();
            if (is_string($api_temperature)) {
                $api_temperature = floatval($api_temperature);
            }
            if ($client_temp->SetAgentVar($this->api_agent, "temperature", $api_temperature)) {
                $this->api_temperature = null;
            }
            else {
                $this->api_temperature = $api_temperature;
            }
        }
        else {
            $this->api_temperature = $api_temperature;
        }
    }

    public function get_api_top_p() {
        if ($this->send_instructions_to_server) {
            $client_temp = new Holo6PHPClient();
            $online_response = $client_temp->GetAgentVar($this->api_agent, "top_p");
            if ($online_response) {
                return $online_response;
            }
            if ($this->api_top_p !== null) {
                return $this->api_top_p;
            }
            return 0.5;
        }
        else {
            return $this->api_top_p;
        }
    }

    public function set_api_top_p($api_top_p) {
        if ($this->send_instructions_to_server) {
            $client_temp = new Holo6PHPClient();
            if (is_string($api_top_p)) {
                $api_top_p = floatval($api_top_p);
            }
            if ($client_temp->SetAgentVar($this->api_agent, "top_p", $api_top_p)) {
                $this->api_top_p = null;
            }
            else {
                $this->api_top_p = $api_top_p;
            }
        }
        else {
            $this->api_top_p = $api_top_p;
        }
    }
};


class Holo6JSClientSettings {
    public $agent_role = null;
    public $json_file_name = null;

    public $app_enabled = null;
    public $app_debug_level = null;

    public $api_settings = null;

    public $client_commands = null;
	public $roles_current_message_extra = null;
	public $instructions_after_tool_call = null;
	public $roles_welcome_message = null;
	public $roles_welcome_topics = null;
	public $ui_active_window_title = null;
	public $ui_font_size = null;
	public $ui_window_dockable = null;
	public $ui_undocked_window_max_height = null;
	public $ui_full_window_max_height = null;
	public $ui_notification_type_after_response = null;
	public $cl_accept_web_writer = null;
	public $cl_enable_web_writer = null;
	public $ui_undock_on_mouse_hover = null;
	public $ui_min_width_for_undocked = null;
	public $ui_show_messages_list = null;
	public $ui_main_window_style = null;
	public $ui_style_light_theme_params = null;
    public $avatar_config = null;

    public function __construct($agent_role=null) {
        if ($agent_role === null) {
            if (holo6_is_current_admin()) {
                $this->agent_role = "writer";
            }
            else {
                $this->agent_role = "public";
            }
        }
        else {
                $this->agent_role = $agent_role;
        }
        $this->json_file_name = "Holo6Config-" . $this->agent_role . ".json";
        $this->api_settings = new Holo6JSClientAPISettings($this->agent_role);
        $this->avatar_config = new Holo6AvatarConfig();
    }

    public static function SelectSettingsCTOR($is_admin) {
        if ($is_admin) {
            return new Holo6JSClientSettings("writer");
        }
        else {
            return new Holo6JSClientSettings("public");
        }
    }

    public function get_roles_welcome_topics_str() {
        if ($this->roles_welcome_topics && is_array($this->roles_welcome_topics)) {
            $retour = "";
            foreach ( $this->roles_welcome_topics as $topic ) {
                $retour .= $topic . ";";
            }
            return $retour;
        }
        return "";
    }

    public function set_ui_undocked_window_max_height($value_str) {
        $v = intval($value_str);
        $this->ui_undocked_window_max_height = ($v > 0) ? $v :$value_str;
    }

    public function set_ui_full_window_max_height($value_str) {
        $v = intval($value_str);
        $this->ui_full_window_max_height = ($v > 0) ? $v :$value_str;
    }

    public function get_ui_undocked_window_max_height_value() {
        return $this->ui_undocked_window_max_height;
    }

    public function get_ui_full_window_max_height_value() {
        return $this->ui_full_window_max_height;
    }

    private function _get_ui_full_window_max_height_json() {
        return $this->_conv_max_height_json($this->ui_full_window_max_height);
    }

    private function _get_ui_undocked_window_max_height_json() {
        // return "auto";
        return $this->_conv_max_height_json($this->ui_undocked_window_max_height);
    }

    public function get_ui_window_dockable_option() {
        return $this->_get_option_generique_bool("holo6_ui_window_dockable");
    }

    public function get_ui_notification_type_after_response() {
        return $this->_get_option_generique_int("holo6_ui_notification_type_after_response");
    }

    public function get_cl_accept_web_writer() {
        return $this->cl_accept_web_writer;
    }

    public function get_cl_enable_web_writer() {
        return $this->cl_enable_web_writer;
    }

    public function get_cl_web_writer_command() {
        return "//";
    }

    public function get_app_enabled_option() {
        return $this->_get_option_generique_bool("holo6_app_enabled");
    }

    public function get_app_enabled_main_site() {
        return $this->_get_option_generique_bool("holo6_app_enabled", Holo6CommonSettings::get_common_site_id());
    }

    public function getCurrentAgentRole() {
        return $this->agent_role;
    }

    public function isPublicAgent() {
        return $this->agent_role == "public";
    }

    public function injectPageContent() {
        return $this->isPublicAgent();
    }

//     public function settings_export_filename() {
//         return $this->json_file_name;
//     }

    public function current_settings_file_path($html_attribute=false) {
        $json_file_name = "config/" . holo6_get_current_site_name() . "/" . $this->json_file_name;
        if ($html_attribute) {
            return rawurlencode($json_file_name) . "?ver=" . holo6_client_format_mtime_file($json_file_name);
        }
        return $json_file_name;
    }

    public function get_current_theme_name() {
        return "light";
    }

    static function public_setting_file_path($html_attribute=false) {
        $json_file_name = "config/" . holo6_get_current_site_name() . "/Holo6Config-public.json";
        if ($html_attribute) {
            return rawurlencode($json_file_name) . "?ver=" . holo6_client_format_mtime_file($json_file_name);
        }
        return $json_file_name;
    }

    static function writer_setting_file_path($html_attribute=false) {
        $json_file_name = "config/" . holo6_get_current_site_name() . "/Holo6Config-writer.json";
        if ($html_attribute) {
            return rawurlencode($json_file_name) . "?ver=" . holo6_client_format_mtime_file($json_file_name);
        }
        return $json_file_name;
    }

    static function summarizer_setting_file_path($html_attribute=false) {
        $json_file_name = "config/" . holo6_get_current_site_name() . "/Holo6Config-summarizer.json";
        if ($html_attribute) {
            return rawurlencode($json_file_name) . "?ver=" . holo6_client_format_mtime_file($json_file_name);
        }
        return $json_file_name;
    }

    public static function settings_reference_path($force_current_network_id=null) {
        $base_path = constant("HOLO6_CLIENT_DIR") . "/config/base/";
        $current_locale = holo6_get_current_locale_installation($force_current_network_id);
        if (file_exists($base_path . "Holo6Config-base-" . $current_locale . ".json")) {
            return $base_path . "Holo6Config-base-" . $current_locale . ".json";
        }
        return $base_path . "Holo6Config-base-en.json";
    }

    public function json_file_exists() {
        $json_file = constant("HOLO6_CLIENT_DIR") . "/config/" . holo6_get_current_site_name() . "/" . $this->json_file_name;
        return file_exists($json_file);
    }

    public function json_file_exists_site_id($current_network_id) {
        $json_file = constant("HOLO6_CLIENT_DIR") . "/config/" . holo6_get_site_name($current_network_id) . "/" . $this->json_file_name;
        return file_exists($json_file);
    }

    public function get_file_data() {
        $json_file = constant("HOLO6_CLIENT_DIR") . "/config/" . holo6_get_current_site_name() . "/" . $this->json_file_name;
        if (file_exists($json_file)) {
            return file_get_contents($json_file);
        }
        return null;
    }

    public function get_file_data_site_id($current_network_id) {
        $json_file = constant("HOLO6_CLIENT_DIR") . "/config/" . holo6_get_site_name($current_network_id) . "/" . $this->json_file_name;
        if (file_exists($json_file)) {
            return file_get_contents($json_file);
        }
        return null;
    }

    public function load_profil_from_file($json_file, $force_values_array=null) {
        if (file_exists($json_file)) {
            $json_content = file_get_contents($json_file);
            // holo6_log($json_file);
            // var_dump($json_content);
            return $this->load_profil_from_json_str($json_content, $force_values_array);
        }
        // holo6_log("Le fichier n'existe pas: ". $json_file);
        return false;
    }

    public function load_profil_from_json_str($json_content, $force_values_array=null) {
        $json_data = json_decode($json_content, true);
        if ($force_values_array) {
            $json_data = holo6_fusion_dicts($force_values_array, $json_data);
        }
        return $this->load_profil_from_array_str($json_data);
    }

    public function load_profil_from_array_str($json_data) {
        if ($json_data === null) {
        }
        else {
            $agent_role = $this->getCurrentAgentRole();
            if ($json_data["core"]["client"]["api"]["server"] === null) {
            }
            else if (($this->api_settings->load_profil_from_array_str($json_data))) {
                $config_roles_list = $json_data["core"]["client"]["roles"];
                $config_role = $config_roles_list[$agent_role];
                $config_ui = $json_data["apps"]["ui"];
                $config_cl = $json_data["apps"]["cl"];

                $this->app_enabled = $json_data["core"]["enabled"];
                $this->app_debug_level = $json_data["core"]["debug_level"];
                $this->instructions_after_tool_call = $json_data["core"]["client"]["instructions"]["after_tool_call"];

                $this->client_commands = $json_data["core"]["client"]["commands"];

                $this->roles_current_message_extra = $config_role["instructions"]["current_message_extra"];
                $this->roles_welcome_message = $config_role["welcome_message"];
                $this->roles_welcome_topics = $config_role["welcome_topics"];

                if ($config_ui) {
                    $this->ui_active_window_title = $config_ui["undocked_window_state"]["title"];
                    $this->ui_font_size = $config_ui["font_size"];
                    $this->ui_window_dockable = $config_ui["window_dockable"];
                    $this->ui_notification_type_after_response = $config_ui["notification_type_after_response"];
                    $this->ui_undock_on_mouse_hover = $config_ui["undock_on_mouse_hover"];
                    $this->ui_min_width_for_undocked = $config_ui["minimal_width_for_undocked"];
                    $this->ui_show_messages_list = $config_ui["show_messages_list"];
                    $this->ui_main_window_style = $config_ui["main_window_style"];
                    $this->ui_undocked_window_max_height = $config_ui["undocked_window_state"]["size"]["max_height"];
                    $this->ui_full_window_max_height = $config_ui["full_window_state"]["size"]["max_height"];
                }

                if ($config_cl) {
                    $this->cl_accept_web_writer = array_key_exists("writer", $config_roles_list);
                    $this->cl_enable_web_writer = ($config_cl["web_writer"] != null) && $this->cl_accept_web_writer;
                }
                
                $current_theme_name = $this->get_current_theme_name();
                $this->ui_style_light_theme_params = $config_ui["style_params"]["themes"][$current_theme_name];
                return true;
            }
        }
        return false;
    }

	public function load_profil_current_site() {
        $json_file = constant("HOLO6_CLIENT_DIR") . "/config/" . holo6_get_current_site_name() . "/" . $this->json_file_name;
        if ($this->load_profil_from_file($json_file, null) === true) {
            return true;
        }
        else {
            $this->restore_settings(true, true, null); // Tente de restaurer les paramètres par défaut automatiquement si il y a un problème avec les paramètres actuels.
            $notifications_manager = new Holo6Notifications();
            $notifications_manager->addNotificationWarning(sprintf(__("Parameters reinitialized due to an error with the current parameters (%s)", "holo6"), $this->json_file_name));
            return $this->load_profil_from_file($json_file, null);
        }
        return false;
	}

    public function export_settings_json($affiche_notification=true, $force_current_network_id=null) {
        $current_network_id = ($force_current_network_id===null) ? holo6_current_site_id() : $force_current_network_id;
        $dossier_config = constant("HOLO6_CLIENT_DIR") . "/config/" . holo6_get_site_name($current_network_id);

        if (! file_exists($dossier_config)) {
            mkdir($dossier_config, 0775, true);
        }

        $dict_data = array(
            "core" => $this->_gen_settings_dict_core(),
            "apps" => array(
                "ui" => $this->_gen_settings_dict_ui(),
                "cl" => $this->_gen_settings_dict_cl()
            )
        );

        // if ($current_network_id == 1) {  // TEMP, test
        //     holo6_log("export_settings_json : (current_network_id=" . $current_network_id . "), (app_enabled=" . gettype($this->app_enabled) . "(" . ($this->app_enabled ? "1" : "0") . "))");
        //     holo6_log_backtrace();
        // }

        $config_file_version = get_network_option($current_network_id, "holo6_config_file_version", 0);
        update_network_option($current_network_id, "holo6_config_file_version", ($config_file_version+1));

        /* Gère les options devant être accessibles avant même le chargement du profil. */
        $this->_set_option_generique_bool("holo6_ui_window_dockable", $this->ui_window_dockable);
        $this->_set_option_generique_int("holo6_ui_notification_type_after_response", $this->ui_notification_type_after_response, $current_network_id);
        $this->_set_option_generique_bool("holo6_app_enabled", $this->app_enabled);

        // $json_data = json_encode($dict_data, JSON_PRETTY_PRINT); // Normalement pour le debug, enregistre le fichier en indentant. Le fichier est plus lisible mais plus lourd.
        $json_data = json_encode($dict_data, 0);

        $json_file_path = $dossier_config . "/" . $this->json_file_name;

        $notifications_manager = new Holo6Notifications();
        if (file_put_contents($json_file_path, $json_data) === false) {
            $notifications_manager->addNotificationError(sprintf(__("Failed to write file to disk (%s).", "holo6"), $this->ui_active_window_title));
            return false;
        }
        else {
            if ($affiche_notification) {
                $notifications_manager->addNotificationSuccess(sprintf(__("Holo6 client settings saved (%s). If the client is loaded on other tabs, you may need to reload them to apply the changes.", "holo6"), $this->getCurrentAgentRole()));
            }
            return true;  // file_put_contents renvoi le nombre d'octets écrits ou false. On préfère renvoyer un booléen
        }
    }

    public function restore_settings($initial_value=false, $affiche_notification=true, $force_values_array=null, $force_current_network_id=null) {
        $current_network_id = ($force_current_network_id===null) ? holo6_current_site_id() : $force_current_network_id;
        $dossier_config = constant("HOLO6_CLIENT_DIR") . "/config/" . holo6_get_site_name($current_network_id);
        // holo6_log("restore_settings(" . $current_network_id . ") : " . $dossier_config);
        if (! file_exists($dossier_config)) {
            mkdir($dossier_config, 0775, true);
        }

        $private_settings = new Holo6PrivateSettings($current_network_id);
        $api_key_defined = $private_settings->APIKeyDefined();

        $notifications_manager = new Holo6Notifications();
        if ($this->load_profil_from_file(self::settings_reference_path($force_current_network_id), $force_values_array)) {
            if ($this->getCurrentAgentRole() === "writer") {
                $this->ui_active_window_title = $this->ui_active_window_title . " " . __("(admin)", "holo6");
                $this->ui_style_light_theme_params["highlight_color_static"] = "#af4b4b";
                $this->ui_style_light_theme_params["highlight_color_hover"] = "#ff6068";
                if ($initial_value === true) {
                    $this->app_enabled = $api_key_defined;
                }
                $this->ui_min_width_for_undocked = 12000;
            }
            else if ($this->getCurrentAgentRole() === "summarizer") {
                if ($initial_value === true) {
                    $this->app_enabled = $api_key_defined;
                    $this->app_debug_level = 10;
                }
            }
            else {  // Public
                $this->ui_style_light_theme_params["highlight_color_static"] = "#58719d";
                $this->ui_style_light_theme_params["highlight_color_hover"] = "#218ebe";
                if ($initial_value === true) {
                    $this->app_enabled = false;
                    // $this->ui_notification_type_after_response = 4;
                }
            }
            
            // if (($current_network_id == 1) &&( $this->getCurrentAgentRole() === "public")) {  // TEMP, test
            //     holo6_log("restore_settings : (current_network_id=" . $current_network_id . "), (getCurrentAgentRole=" . $this->getCurrentAgentRole() . "), (app_enabled=" . gettype($this->app_enabled) . "(" . ($this->app_enabled ? "1" : "0") . "))");
            //     holo6_log_backtrace();
            // }

            if ($initial_value === true) {
                /* Gère les options devant être accessibles avant même le chargement du profil. */
                $this->_set_option_generique_bool("holo6_ui_window_dockable", $this->ui_window_dockable, $current_network_id);
                $this->_set_option_generique_int("holo6_ui_notification_type_after_response", $this->ui_notification_type_after_response, $current_network_id);
                $this->_set_option_generique_bool("holo6_app_enabled", $this->app_enabled, $current_network_id);
                return $this->export_settings_json($affiche_notification, $force_current_network_id);
            }
            else {
                // $this->api_settings->clear_remote_settings();
                $this->api_settings->send_remote_settings();
                $notifications_manager->addNotificationSuccess(__("Settings restored.", "holo6"));
                return true;
            }
        }
        $notifications_manager->addNotificationError(sprintf(__("Failed to restore settings (%s).", "holo6"), $this->ui_active_window_title));
        return false;
    }

    private function _gen_settings_dict_core() {
        $agent_role = $this->getCurrentAgentRole();
        $max_messages_count = ($agent_role === "summarizer") ? 0 : 16;
        
        // $app_language = holo6_get_current_locale();
        $app_language = "auto";

        $dict_data_core_commands = $this->client_commands;

        $dict_data_core_roles = array(
            $agent_role => array(
                "api" => array(
                    "agent" => $this->api_settings->api_agent,
                    "max_completion_tokens" => $this->api_settings->api_max_completion_tokens,
                    "temperature" => $this->api_settings->api_temperature,
                    "top_p" => $this->api_settings->api_top_p,
                ),
                "inject_page_content" => $this->injectPageContent(),
                "max_messages_count" => $max_messages_count,
                "welcome_message" => $this->roles_welcome_message,
                "welcome_topics" => $this->roles_welcome_topics,
                "instructions" => array(
                    "system" => $this->api_settings->roles_system_instructions,
                    "current_message_extra" => $this->roles_current_message_extra
                )
            )
        );

        $dict_data_core_client = array(
            "api" =>  array(
                "server" => $this->api_settings->api_server,
                "key" => $this->api_settings->api_key,
                "stream" => true
            ),
            "ignore_ping_requests" => false,
            "instructions" => array(
                "extra_in_system_message" => true,
                "user_message_prefix" => "",
                "user_message_suffix" => "",
                "extra_message_prefix" => "[START_OF_INFORMATIONS]",
                "extra_message_suffix" => "[END_OF_INFORMATIONS]",
                "after_tool_call" => $this->instructions_after_tool_call
            ),
            "commands" => $dict_data_core_commands,
            "roles" => $dict_data_core_roles
        );

        $debug_level = ($agent_role === "summarizer") ? 10 : $this->app_debug_level;
        // $debug_level = $this->app_debug_level;

        $dict_data_core = array(
            "enabled" => $this->app_enabled,
            "debug_level" => $debug_level,
            "version" => "0.1",
            "default_role" => $this->getCurrentAgentRole(),
            "language" => $app_language,
            "client" => $dict_data_core_client,
        );

        return $dict_data_core;
    }

    private function _gen_settings_dict_ui() {
        $current_agent_role = $this->getCurrentAgentRole();
        if ($current_agent_role === "summarizer") {
            return null;
        }

        $dict_app_ui_full_window_state = array(
            "size" => array("width" => "calc(100% - 8px)", "max_height" => $this->_get_ui_full_window_max_height_json()),
            "border" => array("width" => "2px", "radius" => "6px"),
            "margin" => array("top" => "0px", "bottom" => "0px"),
        );

        $dict_app_ui_undocked_window_state = array(
            "title" => $this->ui_active_window_title,
            "size" => array("width" => "90%", "max_height" => $this->_get_ui_undocked_window_max_height_json()),
            "border" => array("width" => "2px", "radius" => "6px")
        );

        $dict_app_ui_docked_window_state = array(
            "size" => array("width" => "76px", "max_height" => 52),
            "border" => array("width" => "2px", "radius" => "6px")
        );

        $current_theme_name = $this->get_current_theme_name();
        $dict_app_ui_style_params = array(
            "default_theme" => $current_theme_name,
            "themes" => array(
                $current_theme_name => array(
                    "front_color" => $this->ui_style_light_theme_params["front_color"],
                    "active_color" => $this->ui_style_light_theme_params["active_color"],
                    "background_color" => $this->ui_style_light_theme_params["background_color"],
                    "background_color_alt" => $this->ui_style_light_theme_params["background_color_alt"],
                    "highlight_color_static" => $this->ui_style_light_theme_params["highlight_color_static"],
                    "highlight_color_hover" => $this->ui_style_light_theme_params["highlight_color_hover"],
                ),
            ),
        );

        $dict_data_app_ui = array(
            "default_role" => $current_agent_role,
            "web_writer" => null,
            "main_window_style" => $this->ui_main_window_style,
            "font_size" => $this->ui_font_size,
            "window_dockable" => $this->ui_window_dockable,
            "undock_on_mouse_hover" => $this->ui_undock_on_mouse_hover,
            "minimal_width_for_undocked" => $this->ui_min_width_for_undocked,
            "show_messages_list" => $this->ui_show_messages_list,
            "audio" => array(
                "tts" => 1,
                "voice" => 1
            ),
            "notification_type_after_response" => $this->ui_notification_type_after_response,
            "full_window_state" => $dict_app_ui_full_window_state,
            "undocked_window_state" => $dict_app_ui_undocked_window_state,
            "docked_window_state" => $dict_app_ui_docked_window_state,
            "style_params" => $dict_app_ui_style_params
        );

        return $dict_data_app_ui;
    }

    private function _gen_settings_dict_cl() {
        $current_agent_role = $this->getCurrentAgentRole();
        if ($current_agent_role === "public") {
            return null;
        }

        $web_writer_config = ($this->get_cl_enable_web_writer()) ? array(
            "commands_roles" => array(
                $this->get_cl_web_writer_command() => array(
                    "role" => "writer"
                )
            ),
        ) : null;

        $dict_data_app_cl = array(
            "default_role" => $current_agent_role,
            "web_writer" => $web_writer_config
        );
        return $dict_data_app_cl;
    }

    private function _get_option_generique_bool($option_name, $force_current_network_id=null) {
        $current_network_id = ($force_current_network_id===null) ? holo6_current_site_id() : $force_current_network_id;
        $option_name_ext = $option_name . "-" . $this->getCurrentAgentRole();
        $v = get_network_option($current_network_id, $option_name_ext, null);
        
        // holo6_log("_get_option_generique_bool:" . $current_network_id . ":" .$option_name_ext . ":" . $v);

        if ($v === null) {
            return $v;
        }
        else if ($v === 1 or $v === "1") {
            return true;
        }
        else {
            return false;
        }
    }

    private function _conv_max_height_json($max_height_value) {
        if (is_int($max_height_value)) {
            if ($max_height_value >= 250) {
                return $max_height_value;
            }
        }
        else if (is_string($max_height_value)) {
            if (holo6_str_startsWith($max_height_value, "calc(") && holo6_str_endsWith($max_height_value, ")")) {
                return $max_height_value;
            }
            if (holo6_str_endsWith($max_height_value, "%") || holo6_str_endsWith($max_height_value, "px")) {
                return $max_height_value;
            }
        }
        return "auto";
    }

    private function _set_option_generique_bool($option_name, $etat, $force_current_network_id=null) {
        $current_network_id = ($force_current_network_id===null) ? holo6_current_site_id() : $force_current_network_id;
        $option_name_ext = $option_name . "-" . $this->getCurrentAgentRole();

        // holo6_log("_set_option_generique_bool:" . $current_network_id . ":" .$option_name_ext . ":" . $etat);

        if ($etat === true or $etat === 1 or $etat === "1") {
            update_network_option($current_network_id, $option_name_ext, 1);
        }
        else if ($etat === false or $etat === 0 or $etat === "") {
            update_network_option($current_network_id, $option_name_ext, 0);
        }
        else {
            update_network_option($current_network_id, $option_name_ext, 1);
        }
    }

    private function _get_option_generique_int($option_name) {
        $current_network_id = holo6_current_site_id();
        $option_name_ext = $option_name . "-" . $this->getCurrentAgentRole();
        $v = get_network_option($current_network_id, $option_name_ext, null);
        if ($v === null) {
            return 0;
        }
        if (is_string($v)) {
            return intval($v);
        }
        return $v;
    }

    private function _set_option_generique_int($option_name, $etat, $force_current_network_id=null) {
        $current_network_id = ($force_current_network_id===null) ? holo6_current_site_id() : $force_current_network_id;
        $option_name_ext = $option_name . "-" . $this->getCurrentAgentRole();
        update_network_option($current_network_id, $option_name_ext, $etat);
    }
};

?>
